import info.exac.ppr.Bod3D;
import info.exac.ppr.ThreadManager;

/**
 * 
 */

/**
 * @author Exac
 *
 */
public class Hlavni {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		
		if (args.length != 7) {
			System.out.println();
			System.out.println("Integralni vypocet hmotnosti kvadru");
			System.out.println("===================================");
			System.out.println();
			System.out.println("Semestralni prace na PPR");
			System.out.println("Miroslav Exner\tA02221");
			System.out.println("exac@exac.info\twww.exac.info");
			System.out.println();
			System.out.println("Musite zadat celkem 7 argumentu prikazove radky. Musite zadat");
			System.out.println();
			System.out.println("javac Hlavni <x> <y> <z> <d> <c. funkce> <pocet vlaken> <velikost prace>");
			System.out.println("   <x> <y> <z>      - rozmery kvadru");
			System.out.println("   <d>              - integracni krok pro vsechny osy");
			System.out.println("   <c. funkce>      - cislo funkce hustoty 1, 2, nebo 3");
			System.out.println("                         1 - ro(x, y, z) = 1");
			System.out.println("                         2 - ro(x, y, z) = x");
			System.out.println("                         3 - ro(x, y, z) = x+y+z");
			System.out.println("   <pocet vlaken>   - pocet vlaken, do kterych rozdelujeme ulohu");
			System.out.println("   <velikost prace> - v % dil pridelovane prace vlaknu");
			System.out.println();
			System.out.println("napr.:");
			System.out.println("javac Hlavni 20 10 1 0.005 1 5 5");
			return ;
		}

		System.out.println();
		System.out.println("Integralni vypocet hmotnosti kvadru");
		System.out.println("===================================");
		System.out.println();
		System.out.println("Semestralni prace na PPR");
		System.out.println("Miroslav Exner\tA02221");
		System.out.println("exac@exac.info\twww.exac.info");
		System.out.println();		
		
		double x = Double.parseDouble(args[0]);
		double y = Double.parseDouble(args[1]);
		double z = Double.parseDouble(args[2]);
		System.out.println("Rozmery kvadru (x, y, z): " + x + ", " + y + ", " + z);
		double d = Double.parseDouble(args[3]); 
		System.out.println("Integracni krok: " + d);
		int jakaFunkce = Integer.parseInt(args[4]);
		System.out.print("Funkce hustoty: ");
		switch (jakaFunkce) {
			case 1:
				System.out.println("ro(x, y, z) = 1");
				break;
			case 2:
				System.out.println("ro(x, y, z) = x");
				break;
			case 3:
				System.out.println("ro(x, y, z) = x+y+z");
				break;
			default:
				System.out.println("neznama");
				break;
		}
		int pocetVlaken = Integer.parseInt(args[5]);;
		System.out.println("Pocet vlaken: " + pocetVlaken);
		int velikostPrace = Integer.parseInt(args[6]);
		System.out.println("Velikost pridelovane prace: " + velikostPrace + "%");
		System.out.println();
		
		ThreadManager tm = new ThreadManager(new Bod3D(x, y, z), d, jakaFunkce, pocetVlaken, velikostPrace);
		
		tm.start();

		/* Smycka, ktera ceka na dokonceni vypoctu a prubezne zobrazuje stav vlaken */
		while (!tm.isHotovo()) {
			
			tm.vypis();
			
			/* Cekani na aktualizaci */
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				/* Opravdu NECHCI aby se vyjimka jakkoliv resila. Tak se vlakno vzbudilo driv, a co? */
			}			
		}

		
		System.out.println("\nCelkova hmotnost: " + tm.getHmotnost());
		System.out.println("Cas vypoctu: " + tm.getCasVypoctu() + "ms");
	}

}
