with TEXT_IO; use TEXT_IO;
with BUFFER; use BUFFER;

procedure testbuf is

  l_string : constant positive := 40;        -- delka zpravy
  l_buff : constant positive := 4;           -- delka bufferu

  subtype MESSAGE is string(1..l_string);    -- typ zpravy
  kbd_mes: MESSAGE;                          -- zprava z klavesnice

  procedure null_mes (the_mes: out MESSAGE); -- prototyp procedury pro
                                             -- nulovani zpravy
  package B is new G_BUFFER (MESSAGE, l_buff, null_mes);
    -- konkretni verze generic package G_BUFFER
  use B;
  buf: SERVER;   -- deklarace bufferu (tj. vytvoreni obsluzneho tasku)  

  task type CONSUMER is      -- typovy task pro cteni zpravy z bufferu
    -- nema zadne entry
  end;

  task body CONSUMER is      -- telo typoveho tasku
    read_mes : MESSAGE;      -- lok. promenna pro prectenou zpravu
  begin
    delay 0.5;               -- aby se stihlo vypsat ohlaseni hlav.prog.
    put_line("Task CONSUMER pripraven");  
    loop
      null_mes(read_mes);    -- cisteni lokalni promenne
      buf.read(read_mes);    -- !!! rendez-vous s taskem buf
      if read_mes(1..6) = "zhebni" then
        put_line("Task CONSUMER se s Vami louci s pozdravem DDT ZDAR !");
        exit;
      else
        put("Task CONSUMER :");
        put_line(read_mes); new_line;
      end if;
    end loop;
  end CONSUMER;     
      
  procedure null_mes (the_mes: out MESSAGE)is
    -- telo procedury - tela procedur a tasku musi byt az na konci
    -- deklaracni casti (az po dekl. typu a dat) - proto byl na zacatku
    -- prototyp kvuli dosazeni do generic package G_BUFFER
  begin
    for i in 1..l_string loop
      the_mes(i) := ' ';
    end loop;
  end null_mes;
  
begin
  declare
    cons1: CONSUMER;        -- deklarace (vytvoreni) tasku cons1
  begin
    put_line("Demonstracni program - komunikace konkurencnich procesu");
    delay 1.0;              -- aby se stihlo vypsat ohlaseni tasku cons1
    loop
      declare
        num_char : natural;
      begin
        put_line("Zadej nejaky text !");
        null_mes(kbd_mes);
        get_line(kbd_mes, num_char);
        buf.add(kbd_mes);   -- !!! rendez-vous hlav. programu s taskem buf
        delay 1.0;          -- aby task cons1 stihnul vypsat zpravu
        if kbd_mes(1..6) = "zhebni" then
          exit;
        end if;
      end;
    end loop;  
    put_line("Hlavni program - konec komunikace");
  end;                      -- tady dojde k likvidaci tasku cons1
end testbuf;                -- az zde dojde k likvidaci tasku buf

