generic
  -- PARAMETERS

  type ITEM is private;       -- type of vector items
  n: POSITIVE;                -- num of processors
  with procedure null_item (the_item: out ITEM);
			      -- procedure to set null value of item
  with procedure op_item (glob_item: in out ITEM; the_item: in ITEM);

package G_PAR_OP is

  type VECTOR is array (INTEGER range <>) of ITEM;

  type REF_VECTOR is access VECTOR;

  procedure red_op (v: in REF_VECTOR; result: out ITEM);
    -- makes sum of all vectors' items
  procedure set_part (length: in POSITIVE);
    -- sets length of the "bit of work" (10 is the default value)

  private

  task boss is                -- task organizing par. computation
    entry set_part (length: in POSITIVE);          -- client's request
    entry op (v: in REF_VECTOR; result: out ITEM); -- client's request
    entry inc (part_result: in ITEM);
			      -- worker sends partial result
    entry signal;             -- worker signals end of op.
    entry get_next(beg_index: out INTEGER);
			      -- worker gains next part of work
  end boss;

  task type WORKER is         -- task type worker
    entry start_op;           -- start to work
  end WORKER;

  type REF_WORKER is access WORKER;


end G_PAR_OP;

