/* Trida Row implementuje jeden radek tabulky (= jeden ucet) */

class Row {                     // monitor
  private boolean row_lock;     // lock of record (false - free rec.)
  private int key;              // key of record
  private int value;            // value of account

  Row (int par_key, int par_value) {
    row_lock = false; key = par_key; value = par_value;
  }
  Row () { row_lock = false;}

  void set_row (int par_key, int par_value) {
    row_lock = false; key = par_key; value = par_value;
  }
  int get_value () {return value;}
  int get_key () {return key;}

  synchronized boolean test_and_set_lock () {
    boolean old_lock = row_lock;  row_lock = true;
    return old_lock;
  }
  void release_lock () {row_lock = false;}

  void add (int income) {value += income;}

  boolean sub (int outcome) {
    if (outcome <= value) {
      value -= outcome; return true;
    }
    else return false;
  }

  synchronized void print_row() {
    System.out.println(row_lock + "  " + key + "  " + value);
  }
}

/* Public trida Table implementuje pole uctu */
public class Table {         // monitor

  private int[] state;       // 0 - running trns., 1 - done trns.
                             // 2 - aborted trns.
  private int n;             // num. of rows
  private Row[] vector;      // array of rows

  public Table (int par_n, int ini_value) {
    n = par_n;
    vector = new Row[n];
    for (int i = 0; i<n; i++)
      vector[i] = new Row (i, ini_value);
    state = new int[3];
    state[0] = state[1] = state[2] = 0;
  }

  public int get_n () {return n;}

  public int find (int given_key) {
    int j=-1;
    for (int i=0; i<n; i++)   // key = index
      if (given_key == vector[i].get_key()) {
        j = i;  break;
      }
    return j;
  }

  public boolean test_and_set_lock (int row_num) {
    return vector[row_num].test_and_set_lock();
  }

  public void release_lock (int row_num) {
    vector[row_num].release_lock();
  }

  public void add (int row_num, int income) {
    vector[row_num].add(income);
  }

  public boolean sub (int row_num, int outcome) {
    return vector[row_num].sub(outcome);
  }

  synchronized public int sum () {
    int suma = 0;
    for (int i=0; i<n; i++)
      suma += vector[i].get_value();
    return suma;
  }

  synchronized public void inc_state (int index) {
    state[index]++;
  }

  synchronized public void dec_state (int index) {
    state[index]--;
  }

  synchronized public int[] get_state () {
    int[] state_rec = new int[3];
    for (int i=0; i<3; i++) state_rec[i] = state[i];
    return state_rec;
  }

  synchronized public void print_table () {
    for (int i = 0; i < n; i++)
      vector[i].print_row();
    System.out.println();
    System.out.println ("state: "
      + state[0] + "  " + state[1] + "  " + state[2]);
  }
}
