/* PPR1.C - priklad na nasobeni dvou matic. */

#include<stdio.h>
#include <parallel/microtask.h>

#define		SIZE		10

shared float	a[SIZE][SIZE];
shared float	b[SIZE][SIZE];
shared float	c[SIZE][SIZE];

void init_mat(float a[][SIZE], float b[][SIZE]);
void nas_mat(float a[][SIZE], float b[][SIZE], float c[][SIZE]);
void tisk_mat(float a[][SIZE], float b[][SIZE], float c[][SIZE]);


int main(void) {

	int	nprocs;		/* pocet paralelnich procesu */
	
	printf("Zadej pocet procesu : ");
	scanf("%d",&nprocs);
	m_set_procs(nprocs);		/* nastaveni poctu procesu */

	printf("Fork - init_mat().\n");
	m_fork(init_mat, a, b, c);		/* provedeni paralelni inicializace */

	printf("Uspani.\n");
	m_park_procs();
	
	printf("Reaktivace.\n");
	m_rele_procs();
	
	printf("Fork - nas_mat().\n");
	m_fork(nas_mat, a, b, c);
		
	printf("Zabiti.\n");
	m_kill_procs();		/* zabiti deti */
	
	tisk_mat(a, b, c);		/* tisk vysledku */
	
	printf("Hotovo.\n");
	return 0;
	
}


/* Inicializace matic : */

void init_mat(float a[][SIZE], float b[][SIZE]) {

	int	i,j;
	int	nprocs;
	
	nprocs = m_get_numprocs();
	m_lock();
	printf(" init_mat - proces c. %d.\n",m_get_myid());
	m_unlock();
	
	for (i=m_get_myid(); i<SIZE; i+=nprocs) {
		for (j=0; j<SIZE; ++j) {
			a[i][j] = (float)i+j;
			b[i][j] = (float)i-j;
	  }
	}
	
	m_lock();
	printf(" konec init_mat - proces c. %d.\n",m_get_myid());
	m_unlock();

}


/* Nasobeni matic: */

void nas_mat(float a[][SIZE], float b[][SIZE], float c[][SIZE]) {

	int	i,j,k;
	int	nprocs;
	
	nprocs = m_get_numprocs();
	m_lock();
	printf(" nas_mat - proces c. %d.\n",m_get_myid());
	m_unlock();

	for (i=m_get_myid(); i<SIZE; i+=nprocs) {
		for (j=0; j<SIZE; ++j)
			for (k=0; k<SIZE; ++k)
				c[i][k] += a[i][j]*b[j][k];
	}
	
	m_lock();
	printf(" konec nas_mat - proces c. %d.\n",m_get_myid());
	m_unlock();

}


/* Tisk vysledku: */

void tisk_mat(float a[][SIZE], float b[][SIZE], float c[][SIZE]) {

	int	i,j;

	printf("Tisk vysledku ...");
	getchar();
		
	for (i=0; i<SIZE; ++i) {
		for (j=0; j<SIZE; ++j) {
			printf("a[%2d][%2d] = %3.2f, b[%2d][%2d] = %3.2f,  ",
					i,j,a[i][j], i,j,b[i][j]);
			printf("c[%2d][%2d] = %3.2f\n",
					i,j,c[i][j]);
		}
	}
	
}

