
#include <stdio.h>
#include <math.h>
#include <parallel/microtask.h>

#define  N_MEST   10   /* pocet mest */
#define  BITE     1    /* kus prace pro "hungry puppy" */

shared float	nejblize;
shared float	nejdale;
shared int		index1;
shared int		index2;

struct location {
	char *name;
	float x, y;
};

shared struct location mesta[N_MEST]  = {
	{ "PLZEN",    0.  , 100.  },
	{ "PRAHA",    500., -550. },
	{ "KLATOVY",  150., 100.  },
	{ "ROKYCANY", 50.,  300.  },
	{ "STRIBRO",  30.,  80.   },
	{ "SOKOLOV",  80.,  130.  },
	{ "DOMAZLICE",60.,  150.  },
	{ "ROZVADOV", 120., 220.  },
	{ "FOLMAVA", -200., 190.  },
	{ "TACHOV",   100., 270.  },
};

shared struct location lochotin = {
	"LOCHOTIN", 0., 0. };

void find_dis(struct location mesta[]);


main () {

	nejblize = 999999999.0;
	nejdale = 0.0;

	m_fork(find_dis, mesta);

	printf("%s je nejblize k Lochotinu (%3.2f km).\n",
	    mesta[index1].name, nejblize);
	printf("%s je nejdale od Lochotina (%3.2f km).\n",
	    mesta[index2].name, nejdale);

}



void find_dis(struct location mesta[])
{
	int i, base, top;  /* index1, poc. a konc. hodnota */
	float xsqdis, ysqdis, dist;

	while ((base = BITE*(m_next() - 1)) < N_MEST) {
		top = base + BITE;      /* prace pro proces */
		if (top >= N_MEST)
			top = N_MEST - 1;

		for (i = base; i <= top; i++) {
			xsqdis = pow(fabs(lochotin.x - mesta[i].x), 2.);
			ysqdis = pow(fabs(lochotin.y - mesta[i].y), 2.);
	    dist   = sqrt(xsqdis, ysqdis);
	    m_lock();
		    if (dist < nejblize) {
					index1 = i;
			    nejblize = dist;
				}
				else
				if (dist > nejdale) {
					index2 = i;
					nejdale = dist;
				}
			m_unlock();
		}
	}
}
