package Naboj;

import java.math.*;
import java.util.*;

/**
 * <p>Title: Vpoet intenzity pole pomoc vlken</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Martin Podval
 * @version 1.0
 */

public class Delnik extends Thread{
  private Model model;
  private boolean jeX; // Udava zda do vlakna byla poslana x souradnice nebo y
  private ArrayList sloupce; // Udava sloupec, pro ktery to pocitame
  private int pocet; // Udava pocet hodnot ve sloupci

  public Delnik(Model model, ArrayList sloupce, int pocet, boolean jeX) {
    this.model = model;
    this.jeX = jeX;
    this.sloupce = sloupce;
    this.pocet = pocet;
  }

  public void run(){
    // Udelame vypocet pro kazdy bod na plose v danem sloupci
    for(int i=0; i < this.sloupce.size(); i++){
      int sloupec = ((Integer)this.sloupce.get(i)).intValue();

      for (int j = 0; j < this.pocet; j++){
        Vektor vektor;
        if (this.jeX == true)
          vektor = new Vektor(sloupec, j);
        else
          vektor = new Vektor(j, sloupec);

        this.model.GetPlocha().ZapisHodnotu(vektor, this.SpoctiIntenzitu(vektor.GetX(),vektor.GetY()),this.SpoctiSmer(vektor.GetX(),vektor.GetY()));
      }
    }
  }

  /**
   * Vypocte hodnotu intenzity
   * @param x xova souradnice
   * @param y yova souradnice
   * @return hodnota intenzity
   */
  private double SpoctiIntenzitu(int x, int y){
    double polomer = Math.sqrt( ((x*x) + (y*y)) +
                                (this.model.GetNaboj().GetSouradnice().GetZ() * this.model.GetNaboj().GetSouradnice().GetZ()) ); // Vyska naboje

    double konst = 4 * Math.PI * this.model.GetEpsilon_r() * this.model.epsilon;
    double intenzita = Math.abs(this.model.GetNaboj().GetNaboj()) / (konst * polomer * polomer);

    return intenzita;
  }

  private Vektor SpoctiSmer(int x, int y){
    return new Vektor(
        x - this.model.GetNaboj().GetSouradnice().GetX(),
        y - this.model.GetNaboj().GetSouradnice().GetY(),
        0 - this.model.GetNaboj().GetSouradnice().GetZ());
  }

}