package Naboj;

/**
 * <p>Title: Vpoet intenzity pole pomoc vlken</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Martin Podval
 * @version 1.0
 */

public class Hlavni {
  public Hlavni(String[] args) {
    this.TestujArgumenty(args);
    Model model = new Model(
        new Naboj(
                  new Vektor(Integer.parseInt(args[0]),Integer.parseInt(args[1]),Integer.parseInt(args[2])),
                  Float.parseFloat(args[3]) // Hodnota naboje
                  ),
        new Plocha(Integer.parseInt(args[4]),Integer.parseInt(args[5])),
        Float.parseFloat(args[6]), // Relativni permeabilita
        Integer.parseInt(args[7])); // Pocet procesu

    System.out.println("Program vypote intenzitu pro zadanou plochu, parametry prosted a nboj.\n");
    System.out.println("Souadnice nboje: [" + args[0] + ", " + args[1] + ", " + args[2] + "]");
    System.out.println("Hodnota nboje: " + args[3] + "C");
    System.out.println("Velikost plochy: " + args[4] + "x" + args[5]);
    System.out.println("Relativn permeabilita: " + args[6]);
    System.out.println("Poet proces: " + args[7] + "\n");

    model.vypocti();
    model.VypisVysledky();
  }

  /**
   * Vytvori pole argumentu s jednoznacnym prirazenim cislo => hodnota
   * @param args argumenty
   * @return pole argumentu
   */
  private void TestujArgumenty(String[] args){
    if(args.length == 8){
      // naboj_x
      try{
        Integer.parseInt(args[0]);
      }
      catch(NumberFormatException e){
        System.out.println("\nX-ov souadnice nboje mus bt typu integer");
        this.VypisArgumenty();
      }
      // naboj_y
      try{
        Integer.parseInt(args[1]);
      }
      catch(NumberFormatException e){
        System.out.println("\nY-ov souadnice nboje mus bt typu integer");
        this.VypisArgumenty();
      }
      // naboj_z
      try{
        Integer.parseInt(args[2]);
      }
      catch(NumberFormatException e){
        System.out.println("\nZ-ov souadnice nboje mus bt typu integer");
        this.VypisArgumenty();
      }
      // hodnota_naboje
      try {
        Double.parseDouble(args[3]);
      }
      catch (NumberFormatException e) {
        System.out.println("\nHodnota nboje mus bt typu float");
        this.VypisArgumenty();
      }
      // plocha_x
      try{
        Integer.parseInt(args[4]);
      }
      catch(NumberFormatException e){
        System.out.println("\nX-ov velikost plochy mus bt typu integer");
        this.VypisArgumenty();
      }
      // plocha_y
      try{
        Integer.parseInt(args[5]);
      }
      catch(NumberFormatException e){
        System.out.println("\nY-ov velikost plochy mus bt typu integer");
        this.VypisArgumenty();
      }
      // relativni_permeabilita
      try {
        Double.parseDouble(args[6]);
      }
      catch (NumberFormatException e) {
        System.out.println("\nRelativn permeabilita mus bt typu float");
        this.VypisArgumenty();
      }
      // pocet_vlaken
      try{
        Integer.parseInt(args[7]);
      }
      catch(NumberFormatException e){
        System.out.println("\nPoet vlken mus bt typu integer");
        this.VypisArgumenty();
      }

    }
    else{
      // Pokud je pocet argumentu spatne
      System.out.println("Chybn poet argument");
      this.VypisArgumenty();
      System.exit(0);
    }
  }

  private void VypisArgumenty(){
      System.out.println("java -jar naboj.jar naboj_x naboj_y naboj_z hodnota_naboje plocha_x plocha_y relativni_permeabilita pocet_vlaken");
      System.out.println("\nnaboj_x\t\t\tx-ov souadnice nboje");
      System.out.println("naboj_y\t\t\ty-ov souadnice nboje");
      System.out.println("naboj_z\t\t\tz-ov souadnice nboje");
      System.out.println("hodnota_naboje\t\thodnota nboje");
      System.out.println("plocha_x\t\tx-ov rozmr plochy");
      System.out.println("plocha_y\t\ty-ov rozmr plochy");
      System.out.println("relativni_permeabilita\thodnota relativn permeability");
      System.out.println("pocet_vlaken\t\tpoet vlken, kter se maj vytvoit");
  }

  public static void main(String[] args) {
    Hlavni hlavni1 = new Hlavni(args);
  }

}