import java.io.*;
import java.util.Random;

class Data{
	private double sumax,sumay;        //soucet
  private long i;
	Data(){
		sumax = 0;
    sumay = 0;
    i = 0;
	}
	//pricteni hodnot
	synchronized void Add(double psumax,double psumay){
		sumax += psumax;
    sumay += psumay;
    i++;
  }
  long dejPoceti(){
    return i;
  }
  double dejHodnotux(){
    return sumax / i;
  }
  double dejHodnotuy(){
    return sumay / i;
  }
}

class Funkce{
  Funkce(){
  }
  double dejHodnotu(double x,double y){
    return x*x+y*y;
  }
}

class PartMon extends Thread{
	private int		mytag;			//id vlakna
  private int seed = 100;
  private double myh,myya,myyb,myxa,myxb,myx,myy;
  private Random rnd = new Random();
  private Funkce fce = new Funkce();
	private Data out;            //objekt pro ukladani vysledku

	PartMon(int tag,double xa,double ya,double xb,double yb,double h, Data result) throws IOException{
		mytag = tag;
    myxa  = ya;
    myya  = ya;
    myxb  = xb;
    myyb  = yb;
    myh   = h;
    out = result;
	}
	public void run(){
    double uhelx=0,uhely=0;
    double bx , by;
    int pocet_zk = 100;
    seed += seed;
    rnd.setSeed(seed*mytag);
    for (int i = 0;i<pocet_zk; i++ ){
      myy = rnd.nextDouble()*(myyb-myya);
      myx = rnd.nextDouble()*(myxb-myxa);
      bx = fce.dejHodnotu(myx-myh,myy) - fce.dejHodnotu(myx+myh,myy);
      by = fce.dejHodnotu(myx,myy-myh) - fce.dejHodnotu(myx,myy+myh);
      uhelx += Math.acos(2*myh / Math.sqrt((2*myh)*(2*myh)+bx*bx));
      uhely += Math.acos(2*myh / Math.sqrt((2*myh)*(2*myh)+by*by));
      //System.out.println("pocitam - "+String.valueOf(mytag)+"  -  "+String.valueOf(i));
    }
    uhelx = uhelx / pocet_zk;
    uhely = uhely / pocet_zk;
    out.Add(uhelx,uhely);						//pricteni vysledku
  }
}

public class MonteC
{
	public static void main(String[] argv) throws IOException
	{
		int pocet_vlaken = 4;		//implicitni pocet vytvorenych vlaken
    double xa = 0;
    double xb = 10;
    double ya = 0;
    double yb = 10;
    double h = 0.001;
    int pocet_opakovani = 4;
		Data result = new Data();
		ParticularSum[] threadsfield = new ParticularSum[pocet_vlaken];

    // inicializace vlaken jejich vytvoreni a spusteni
		for (int i=0; i<pocet_vlaken; i++ ){
      threadsfield[i] = new ParticularSum(i, xa,ya,xb,yb,h,result);
			threadsfield[i].start();
		}
    // rozdeleni prace mezi vlakna
		for (int i=0; i<pocet_opakovani; i++ ){
      // pokud je co delat spust znovu uspana vlakna
      //System.out.println("spadlo to pred cekanim na konec ");
      for (int p=0; p<pocet_vlaken; p++){ // cekani na ukonceni vlaken
	      try{
 		  	  threadsfield[p].join();
  	    }	catch(InterruptedException e){
	  	    System.out.println("Thread is interrupted!");
	      }
        //System.out.println("pred novym spustenim run() ");
  		  threadsfield[p].run();
      }
		}

    for (int p=0; p<pocet_vlaken; p++){ // cekani na ukonceni vlaken
	    try{
 		 	  threadsfield[p].join();
  	  }	catch(InterruptedException e){
	      System.out.println("Thread is interrupted!");
      }
    }
    System.out.println("spocital jsem   x -  "+String.valueOf( Math.sin(result.dejHodnotux())*(xb-xa)));
    System.out.println("spocital jsem   y -  "+String.valueOf( Math.sin(result.dejHodnotuy())*(yb-ya)));
    System.out.println("celkem -  "+String.valueOf(Math.sin(result.dejHodnotux())*(xb-xa)*Math.sin(result.dejHodnotuy())*(yb-ya) ) );
    System.out.println("hodnot v Monitoru -  "+String.valueOf(result.dejPoceti()));
	}
}

