#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "/opt/pvm3/include/pvm3.h"
#include "help.h"
#define WORK_NAME "worker" /* jmeno spustitelneho souboru workera*/

/* PVM - ukazka vypocetniho modelu Farmer - Workers           */
/* Sef zadava delnikum postupne cela licha cisla do hodnoty m */
/*   a delnik zkouma, zda je to prvocislo. Vysledkem je  pole */
/*   vsech prvocisel az do hodnoty m.                         */
/* Pouzivane kody zprav:                                      */
/*   4 ... broadcast (id sefa  -> delnici)                    */  
/*   5 ... odpoved   (id delnika -> sef)                      */ 
/*   6 ... zadani ukolu (sef -> delnik),                      */
/*         zaporna hodnota cisla znamena konec cinnosti       */
/*   7 ... vysledek     (delnik -> sef),                      */
/*         zaporna hodnota cisla znamena "neni to prvocislo"  */

int main(int argc, char *argv[]) {
  int mytid;      /*  identifikator procesu sef  */
  int *wtids;   /*  identifikatory procesu delnici */
  int num_workers;      /*  pocet delniku */
  char *w_arg[3]; // pole argumentu pro workery
	double *vysledek;
	int mocnina;
  int i,j;  /*  pomocne promenne */
	FILE *fr,*fw;
	double **matice;

 /* kontrola vstupnich parametru*/
 if (argc !=2) { 
	 printf("Spatne zadane vstupni parametry!\n");
	 printf(" pouziti: farmer <jmeno_souboru_s_matici> \n");    
	 exit(1); 
 }
  

	fr = otevri_soubor(argv[1],"r");
	matice = nacti_matici(fr);/* otevrit soubor se vstupnimi daty*/
	printf("Rozmer matice: %d\n",N);
	vypis_matice(matice);

	printf("Zadejte mocninu teto matice:");
	scanf("%d", &mocnina);
	
	num_workers=N;
	/* alokace pole pro tid workeru*/
	if((wtids = (int *) malloc(N*sizeof(int))) == NULL) {
		printf("Malo pameti!\n");
		exit(1);
	}
	
	if((vysledek = (double *) malloc(N*sizeof(double))) == NULL) {
		printf("Malo pameti!\n");
		exit(1);
	}
	
	/* alokace pameti pro parametry workeru*/
	w_arg[0]=aloc_string(30); /*jmeno souboru*/
	w_arg[1]=aloc_string(20); /*Ktery radek matice bude zpracovavat*/
	w_arg[2]=aloc_string(20); /*Mocnina, kterou je treba vypocitat*/
	w_arg[3]=0x00; 
	
	
	mytid = pvm_mytid();  /* prihlaseni do PVM */
	strcpy(w_arg[0],argv[1]);/*Jmeno souboru s matici*/
  sprintf(w_arg[2],"%d",mocnina);
	
	/* vytvoreni delniku */
  for (i=0; i< num_workers; i++) {
		sprintf(w_arg[1], "%d", i);/*Ktery radek se bude zpracovavat*/
		if (pvm_spawn(WORK_NAME, w_arg, 0, "", 1, &(wtids[i])) != 1) {
			fprintf(stderr,"pvm_spawn: Task nebyl vytvoren!\n");
			pvm_exit();  
			exit(1);
		}  
	printf("Vytvoren delnik %d.\n", wtids[i]);
	}
	
	for (i=0; i<num_workers; i++) {
		pvm_recv(wtids[i],5); // blokujici -> ceka na prijem zpravy 
    pvm_upkdouble(vysledek, N, 1); //pole radky, kterou vypocital worker 
		printf("Radka %d\n",i);
		for (j=0;j<N;j++)
			printf("%f\t",vysledek[j]);
		printf("\n");
	}
	
	
	free(w_arg[0]);
  free(w_arg[1]);
  free(w_arg[2]);
	free(w_arg[3]);
  /* ukonceni cinnosti v PVM */
  pvm_exit();
return 0;
}
