/*
Programk na vypocet mocniny matice
Autor : Klabusay Dusan
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/*#include <m>*/
/*#define N 4*/
#define MOCNINA 2
#define RANDOM_MAX 100000000
#define SOUBOR "matice.txt"
int N=0; /*Rozmer matice*/
float **alokuj_matici(void);

/*Nacte vstupni matici ze souboru*/
float **nacti_matici(FILE *fr){
int i=0,j=0;
float **matice,buff;
	printf("Nacitam matici ze souboru :)\n");
	while (fscanf(fr,"%f",&buff) != EOF) 
		i++;
	fseek(fr,SEEK_SET,0);
	N=(int)sqrt(i);
	/*Nemame presny rozmer matice */
	if (N*N != i) {
		printf("Chyba ve vstupnim souboru!!\n");
		if (fclose(fr) == EOF){
			printf("Soubor se nepodarilo uzavrit :( \n");
		}
		exit( 0);
	}
	printf("Rozmer matice:%d\n",N);
	matice=alokuj_matici();
	i=0;
	printf("Nacitam vlastni matici\n");
	while (fscanf(fr,"%f",&buff) != EOF) {
		/*printf("Nacitam prvek [%d][%d]=%f\n",i,j,buff);*/
		matice[i][j]=buff;
		j++;
		if (j==(N)) { 
			j=0; 
			i++;
		}
	}
	if (fclose(fr) == EOF){
		printf("Soubor se nepodarilo uzavrit :( \n");
	}

return matice;
}

FILE *otevri_soubor(char *soubor){
FILE *fr;
if ((fr = fopen(soubor,"r")) == NULL)
	printf("Soubor se nepodarilo '%s' otevrit\n", soubor);
return fr;
}


/*Vypise matici*/
int vypis_matice(float **matice){
	int i,j;
	printf("Vypis matice:\n");
	for (i=0;i<N;i++){
		for (j=0;j<N;j++){
			printf("%f\t",matice[i][j]); 
		}
	printf("\n");
	}
	return 1;
}
/*Naalokuje misto pro matici*/
float **alokuj_matici(void){
	float **matice;
	int i;
	printf("Alokuji misto pro matici\n");
	matice=(float **)malloc(N*sizeof(float *));
	for (i=0;i<N;i++)
		matice[i]=(float *)malloc(N*sizeof(float *));
	return (matice);
}

int vypis_radek(float *matice[N]){
int i;
for (i=0;i<N;i++)
	printf("%f\t",matice[N][i]);
printf("\n");
return 1;
}
/*Hlavas*/
int main(){
	float **n_matice;
	float **k_matice, **pom_matice,pomocna=0.0;
	int i,j,pom_i,pom_j,n_i,n_j,mocnina;
	float vysledek[10],pomoc[10];

	n_matice = nacti_matici(otevri_soubor(SOUBOR));	
	vypis_matice(n_matice);
	k_matice=alokuj_matici();
	pom_matice=alokuj_matici();	
	for (i=0;i<N;i++)
		for (j=0;j<N;j++){
			pom_matice[i][j]=n_matice[i][j];
			k_matice[i][j]=pom_matice[i][j];
			vysledek[j]=pom_matice[i][j];
			pomoc[j]=pom_matice[i][j];
		}
	printf("Vypis pocatecniho vysledku\n");
	for (i=0;i<N;i++)
		printf("%f\t",vysledek[i]);
	printf("\n");
	for(mocnina=1;mocnina<MOCNINA;mocnina++){	
		for (pom_i=0;pom_i<N;pom_i++){
			for (pom_j=0,n_i=0;pom_j<N;pom_j++,n_i++){
				pomocna = 0;
				for (n_j=0;n_j<N;n_j++){
					pomocna += pom_matice[pom_i][n_j]*n_matice[n_j][n_i];
				}
			k_matice[pom_i][pom_j]=pomocna;
			}
		}
	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
			pom_matice[i][j]=k_matice[i][j];
	}
	int radek =1;
	for (mocnina =1;mocnina<MOCNINA;mocnina++){
		for (pom_j=0,n_i=0;pom_j<N;pom_j++,n_i++){
				pomocna = 0;
				for (n_j=0;n_j<N;n_j++){
					
					pomocna += pomoc[n_j]*n_matice[n_j][n_i];
					printf("nasobim pomoc[%d]*n_matice[%d][%d]=%f\n",n_j,n_j,n_i,pomocna);
				}
			/*printf("%f\n",pomocna);*/
			vysledek[pom_j]=pomocna;
			}
		for (i=0;i<N;i++)
			pomoc[i]=vysledek[i];		
	}
	printf("Vysledek:\n");
	for (i=0;i<N;i++)
			printf("%f\t",vysledek[i]);
	printf("\n");
	vypis_matice(n_matice);
	vypis_matice(k_matice);
	
	
	
	return 0;
}
