package ppr.smol;

/**
 * @author smol
 * 
 */
import java.io.*;
import java.io.Serializable;
import java.util.Random;


/**
 * @author smol
 * @version 0.1 datum: 19.11.2002
 * class Matrix can generate matrix with given dimension, it also stores its private patterns, which can ben randomly placed into matrix
 */
public class Matrix implements Serializable{
	private int [][] matice;
	private int rozmer = 5;
	private Vzorky vzorky;
	public static int RAND_MAX = 6;	//timto intem lze menit maximalni hodnoty v generovane matici
	/**
	 * Constructor for Matrix with dimension
	 */
	Matrix(int rozmer){
		this.rozmer = rozmer;
		generateMatice();
		vzorky = Vzorky.generateVzorky();
//		vzorky.printOutVzorce();
	}
	/**
	 * create Matrix from file specified by, filename for read serialized object from file
	 */
	public static Matrix readMatrix(String filename)  throws IOException,ClassNotFoundException{
		ObjectInputStream  vstup = new ObjectInputStream(new FileInputStream(filename));
		Matrix returnM = (Matrix)vstup.readObject();
		
	return returnM;
	}
	/**
	 * save matrix to file
	 */
	void saveMatrix(String filename) throws IOException{
		ObjectOutputStream vystup = new ObjectOutputStream(new FileOutputStream(filename));
		vystup.writeObject(this);
		vystup.close();
	}
	/**
	 * generate new Matrix with dimension rozmer
	 */
	void generateMatice(){
		Random generator = new Random();
		matice = new int[this.rozmer][this.rozmer];
		for(int i = 0; i < this.rozmer; i++){
			for (int j = 0; j < this.rozmer; j++)
				matice[i][j] = generator.nextInt(this.RAND_MAX);
		}
	}
	/**
	 * Print out inside of matrix
	 */
	void printOutMatrix(){
	for(int i = 0; i < this.rozmer; i++){
		System.out.println();
			for (int j = 0; j < this.rozmer; j++)
			if (matice[i][j] < 10)
				System.out.print(" "+matice[i][j]+" ");
			else System.out.print(""+matice[i][j]+" ");
		}
		System.out.println();
	}	
	/**
	 * Returns the rozmer.
	 * @return int
	 */
	public int getRozmer() {
		return rozmer;
	}

	/**
	 * Sets the rozmer.
	 * @param rozmer The rozmer to set
	 */
	public void setRozmer(int rozmer) {
		this.rozmer = rozmer;
	}
	/**
	 * Returns the random_max.
	 * @return int
	 */
	public int getRandom_max() {
		return this.RAND_MAX;
	}

	/**
	 * Sets the random_max.
	 * @param random_max The random_max to set
	 */
	public void setRandom_max(int random_max) {
		this.RAND_MAX = random_max;
	}
	/**
	 * Returns the vzorky.
	 * @return Vzorky
	 */
	public Vzorky getVzorky() {
		return vzorky;
	}
	/**
	 * Sets the vzorky.
	 * @param vzorky The vzorky to set
	 */
	public void setVzorky(Vzorky vzorky) {
		this.vzorky = vzorky;
	}
	/**
	 * This method return an array[], array is sub-array of original matrix
	 * @param x means the X index in matrix
	 * @param y means the Y index in matrix
	 */
	public synchronized int getXY(int x, int y){
		return matice[x][y];
	}
	/**
	 * This method writes
	 * @param 
	 */
	public synchronized void setXYVal(int x, int y, int newVal){
		this.matice[x][y] = newVal;
	}
	/**
	 * This method randomly place patterns
	 */
	void placeVzorky(int amount){
		int x,y;
		Random generator = new Random();
		for (int kolik = 0; kolik < amount ; kolik++){
		
			x = generator.nextInt(this.rozmer);
			y = generator.nextInt(this.rozmer);
			System.out.println("nasazuji vzorek na ["+(x)+","+(y)+"]  " );			
			for(int i = 0; i <vzorky.getRozmer(); i++){
				if ((this.getRozmer()-(i+x))<=0)
					continue;
				for(int j = 0;  j < vzorky.getRozmer(); j++){
					if ((this.getRozmer()-(j+y))<=0)
					continue;
					this.matice[x+i][y+j] = this.vzorky.vzorce[i][j];
				}
			}
		}
	}
	/**
	 * metoda pro zapsani matice jako txt souboru
	 */
	public void toTxt(String filename) {
		try {
			PrintWriter tisk = new PrintWriter(
											new BufferedWriter(
											new FileWriter(filename+".txt")));
			tisk.println(this.rozmer);											
			for(int i = 0; i < this.rozmer ; i++){
				for(int j = 0; j < this.rozmer ; j++){
					//System.out.print(getXY(i,j)+" ");
					tisk.print(getXY(i,j)+"  ");
				}
				tisk.println();
			}
			tisk.close();
			this.vzorky.toTxt(filename+"-vzorky.txt");
		} catch (IOException e) {
			System.out.println("chyba pri otvirani souboru");
		}
	}
	
	public void printOutVzorky() {
		this.vzorky.printOutVzorce();
	}
	/**
	 * testovaci metoda tridy Matrix
	 */
	public static void main(String[] args)  throws IOException,ClassNotFoundException{
		
		for(int i =0; i < 10;i++){
			Matrix matice = new Matrix(5+i);	
			matice.toTxt("matice"+i+"-");	
		}
		System.out.println("\n--po testovani generovani vzorku--");
/*		Vzorky mojeVzorky = Vzorky.generateVzorky();
		matice.setVzorky(mojeVzorky);
		mojeVzorky.printOutVzorce();
		
		matice.setRandom_max(20);*/
/*		matice.printOutMatrix();
		matice.toTxt("matice");
	*/	
	/*	System.out.println("\n--po nasazeni vzorku--");
		matice.placeVzorky(3);
		matice.printOutMatrix();
		matice.saveMatrix("Matrix.save");
		matice = null;
		
		System.out.println("\nmatice po obnoveni");
		Matrix matice2 = Matrix.readMatrix("Matrix.save");
		matice2.printOutMatrix();
*/		
	}
}
