package ppr.smol;
import java.util.*;
import java.lang.Thread;
/**
 * @author smol
 *
 */
public class MatrixSearch {
	private Matrix matice;
	private Vzorky replace;
	private Worker[] delnici;
	private static int workerSum = 0;
	private Collection vysledky;
	/**
		 * @author smol
		 * @versioin 0.1 datum: 18.11.2002
		 *
		 */
	class Worker extends Thread {
		private int x,y;
		private int [][] data;
		private int workerId;
		
		public Worker(int x,int y){
			super();
			this.x = x;
			this.y = y;
			this.data = replace.getVzorce();
			workerId = giveId();
			System.out.println("vytvoren delnik "+workerId+"  pracuji na ["+x+","+y+"]");
		}
		/** this method is a body of Worker, it search for the pattern and replace it, if succeds in search
		 */
		public void run(){
			for (int i = 0; i < replace.getRozmer(); i++)
				for (int j = 0; j < replace.getRozmer(); j++){
					if(hledej(x+i,y+j)){
						zamen(x+i,y+j);
						System.out.println(workerId+" nasel na ["+(x+i)+","+(y+j)+"]");
						Vysledek vysledek = new MatrixSearch.Vysledek(x+i,y+j,this.workerId);
						addVysledek(vysledek);
						decrementWorkers();
						return;
					}
			}
			decrementWorkers();
			return;
		}
		/* samotne prohledani od daneho indexu a vraceni vysledku */
		boolean hledej(int x, int y){
			int [][] vzorce = matice.getVzorky().getVzorce();

			for(int i = 0; i < replace.getRozmer(); i++)
				for(int j = 0; j < replace.getRozmer(); j++){
					if( ((x+i) > (matice.getRozmer()-1)) || ((y+j) > (matice.getRozmer() -1) ))
						return false;
					if(matice.getXY(x+i,y+j) != vzorce[i][j])
						return false;
				}
			return true;		
		}
		void zamen(int x, int y){
			for (int i = 0; i < replace.getRozmer(); i++)
				for (int j = 0; j < replace.getRozmer(); j++)
					matice.setXYVal(x+i,y+j,data[i][j]);
		}
		
		boolean isIn(int x, int y){
			if( (x <= matice.getRozmer())&&(y <= matice.getRozmer()))
				return true;
			return false;
		}
	}
	/**
	 * @author smol
	 * this class is used for a worker's result
	 */
	private class Vysledek{
		private int
			 souradniceX,
			 souradniceY,
			 workerId;
		boolean uspech;
		Vysledek(int x, int y, int ID){
			this.souradniceX = x;
			this.souradniceY = y;
			this.workerId = ID;
			this.uspech = true;
		}
		/**
		 * Returns the souradnice.
		 * @return int[][]
		 */
		public int getSouradniceX() {
			return this.souradniceX;
		}
		/**
		 * Returns the souradnice.
		 * @return int[][]
		 */
		public int getSouradniceY() {
			return this.souradniceY;
		}
		/**
		 * Returns the uspech.
		 * @return boolean
		 */
		public boolean isUspech() {
			return uspech;
		}
		/**
		 * Print out the Vylsedek in HRF (Human Readable Form)
		 */
		public String toString(){
			return "nalezeno na ["+souradniceX+","+souradniceY+"]";
		}
	} /* end of class MatrixSearch.Vysledek */
	/** implicitni konstruktor
	 */
	MatrixSearch(){
		this.vysledky = new ArrayList();
	}
	synchronized void addVysledek(Vysledek vysledek){
		this.vysledky.add(vysledek);
	}
	void tahoun(){
		int naRadek = this.matice.getRozmer() / this.replace.getRozmer();
		int workersSum =naRadek*naRadek;
		System.out.println("Pocet vytvarenych delniku: "+workersSum);
		this.delnici = new Worker[workersSum];

		for(int i = 0; i <naRadek; i++)
			for( int j = 0; j < naRadek; j++)	// vytvoreni spravneho poctu delniku
				 this.delnici[i*naRadek+j] = new MatrixSearch.Worker(i*this.replace.getRozmer(),j*this.replace.getRozmer());
 		for( int i = 0; i < (this.delnici.length); i++){	//spusteni samotnych delniku
 			this.delnici[i].start();
 		}
	}
	synchronized void decrementWorkers(){
		workerSum--;
		System.out.println("zbyva : "+workerSum);
		notify();
	}
	
	synchronized void  waitForWorkers(){
		while(this.workerSum > 0){		/* umele uspani a cekani na workery */
			try {
				wait();
			} catch (InterruptedException e) {
			}
		}
	}
	synchronized int giveId(){
		return ++workerSum;
	}
	/**
	 * Method searchAndReplace.
	 * @param matrix Matrix that we want to search
	 * @param patterns Patterns to replace original
	 */
	public static void searchAndReplace(Matrix matrix, Vzorky patterns){
		MatrixSearch hledac = new MatrixSearch();
		hledac.matice = matrix;
		hledac.replace = patterns;
		hledac.tahoun();
		hledac.waitForWorkers();
		System.out.println("-----------------------------------------");
		System.out.println("- tisk vysledku -");
		System.out.println("-----------------------------------------");
		int i =0;
		Iterator e = hledac.vysledky.iterator();
		while(e.hasNext()){
 			System.out.println((Vysledek) e.next());
 			i++;
		}
		System.out.println("celkem vzorec nalezen "+i+" vysledku");
	}
}
