package ppr.smol;

import java.util.*;

import org.omg.CORBA.PRIVATE_MEMBER;
/**
 * @author smol
 *
 */
public class MatrixSearchDynamic {
	WorkerD [] delnici;
	private static int workerSum = 5;
	private Matrix matice;
	private Vzorky replace;
	private Collection vysledky;
	private int citac = 0;
	private boolean done = false;
	private int celkem;
	
	MatrixSearchDynamic(){
		this.vysledky = new ArrayList();
	}
	
	class Pozice{
		private int x,y;
		Pozice(int x, int y){
			this.x = x;
			this.y = y;
		}
		public int getX() {	return x;}
		public int getY() {	return y;}
	}
	
	class WorkerD extends Thread {
		private int workerId;
		private int [][] data; 
		private Pozice pozice;
		
		public WorkerD(){
			super();
			workerId = giveId();
			this.data = replace.getVzorce();
			//System.out.println("vytvoren delnik "+workerId);
		}
		/** this method is a body of Worker, it search for the pattern and replace it, if succeds in search
		 */
		public void run(){
			while( isDone() == false){

				pozice = getPozice();	
				try {
					sleep(10);		// zpomalení, aby se dostala prace i na ostatní dělníky
				} catch (InterruptedException e) {
				}
				if(hledej(pozice.getX(),pozice.getY())){
					zamen(pozice.getX(),pozice.getY());
					System.out.println("dělník číslo "+workerId+" našel na ["+pozice.getX()+","+pozice.getY()+"]");
					Vysledek vysledek = new MatrixSearchDynamic.Vysledek(pozice.getX(),pozice.getY(),this.workerId);
					addVysledek(vysledek);
				}
			}
			decrementWorkers();
			return;
		}
		/* samotne prohledani od daneho indexu a vraceni vysledku */
		boolean hledej(int x, int y){
			int [][] vzorce = matice.getVzorky().getVzorce();

			for(int i = 0; i < replace.getRozmer(); i++)
				for(int j = 0; j < replace.getRozmer(); j++){
					if( ((x+i) > (matice.getRozmer()-1)) || ((y+j) > (matice.getRozmer() -1) ))
						return false;
					if(matice.getXY(x+i,y+j) != vzorce[i][j])
						return false;
				}
			return true;		
		}
		void zamen(int x, int y){
			for (int i = 0; i < replace.getRozmer(); i++)
				for (int j = 0; j < replace.getRozmer(); j++)
					matice.setXYVal(x+i,y+j,data[i][j]);
		}
		
	}
	/** vytvari dany pocet delniku a ceka na vysledky
	 */
	void hledej(int pocetWorkers){
		System.out.println("Počet vytvářených dělníků: "+pocetWorkers+", spouštím výpočet.");
		this.delnici = new WorkerD[pocetWorkers];
		this.celkem = pocetWorkers;
		this.workerSum = 0;
		for(int i = 0; i < delnici.length; i++){
			this.delnici[i] = new WorkerD();
		}
		
		for(int i = 0; i < delnici.length; i++){
			this.delnici[i].start();
		}			
	}
	/** cekani na vsechny delniky az skonci 
	 */
	synchronized void  waitForWorkers(){
		while(this.workerSum > 0){		/* umele uspani a cekani na workery */
			try {
				wait();
			} catch (InterruptedException e) {
			}
		}
	}
	/** prideluje delnikum praci
	 */
	synchronized Pozice getPozice(){
		int x = (int)(citac % matice.getRozmer());
		int y = citac / matice.getRozmer();
		Pozice vrat = new Pozice(x,y);
		citac++;
		if(citac >= (matice.getRozmer()*matice.getRozmer()))
			this.done = true;
		return vrat;
	}
	/**  jednozancne prideluje jednotlivym workerum ID */
	synchronized int giveId(){	return ++workerSum;}
	
	synchronized boolean isDone(){ return done;}
	synchronized void decrementWorkers(){
		workerSum--;
		if(workerSum == 0)
			System.out.println("Zbývá "+workerSum+" dělníků, končím.");
		notify();
	}
	synchronized void addVysledek(Vysledek vysledek){
		this.vysledky.add(vysledek);
	}
	/**
	 * Method searchAndReplace.
	 * @param matrix Matrix that we want to search
	 * @param patterns Patterns to replace original
	 */
	public static void searchAndReplace(Matrix matrix, Vzorky patterns){
		MatrixSearchDynamic hledac = new MatrixSearchDynamic();
		hledac.matice = matrix;
		hledac.replace = patterns;
		hledac.hledej(10);
		hledac.waitForWorkers();
		System.out.println("-----------------------------------------");
		System.out.println("- tisk výsledků -");
		System.out.println("-----------------------------------------");
		int i =0;
		Iterator e = hledac.vysledky.iterator();
		while(e.hasNext()){
 			System.out.println((Vysledek) e.next());
 			i++;
		}
		System.out.println("vzorec celkem nalezen "+i+" krát.");
	}
	
private class Vysledek{
		private int
			 souradniceX,
			 souradniceY,
			 workerId;
		boolean uspech;
		Vysledek(int x, int y, int ID){
			this.souradniceX = x;
			this.souradniceY = y;
			this.workerId = ID;
			this.uspech = true;
		}
		/**
		 * Returns the souradnice.
		 * @return int[][]
		 */
		public int getSouradniceX() {
			return this.souradniceX;
		}
		/**
		 * Returns the souradnice.
		 * @return int[][]
		 */
		public int getSouradniceY() {
			return this.souradniceY;
		}
		/**
		 * Returns the uspech.
		 * @return boolean
		 */
		public boolean isUspech() {
			return uspech;
		}
		/**
		 * Print out the Vylsedek in HRF (Human Readable Form)
		 */
		public String toString(){
			return "nalezeno na ["+souradniceX+","+souradniceY+"]";
		}
	} /* end of class MatrixSearch.Vysledek */

}
