package ppr.smol;

/**
 * @author smol
 * @version 0.1 datum: 20.11.2002
 * This class is userd to test Matrix and MatrixSearch classes
 */
public class Program {
	private static final int MW = 20;
	private static final int PC = 6;
	
	/**
	 * Method main. Testing the MatrixSearch class
	 * @param args are parameters from command line
	 */
	public static void main(String[] args) {
		int mw = 0;	// rozmer matice 
		int pc = 0;	// pocet nahodneho rozmisteni

		/* nudne vyporadani se s argumenty */
		if(args.length == 1){
			if(args[0].equalsIgnoreCase("--help"))
				uziti();
		}
		if(args.length == 2){
			if(args[0].equalsIgnoreCase("-mw"))
				try{
				mw = Integer.parseInt(args[1]);
				}catch(NumberFormatException e){
					System.out.println("chyba argumentu");
				}
			else
			if(args[0].equalsIgnoreCase("-vc"))
				try{
				pc = Integer.parseInt(args[1]);
				}catch(NumberFormatException e){
					System.out.println("chyba argumentu");
				}
		}
		if(args.length == 4){
			if(args[0].equalsIgnoreCase("-mw")){
				try{
				mw = Integer.parseInt(args[1]);
				}catch(NumberFormatException e){
					System.out.println("chyba argumentu");
				}
				if(args[2].equalsIgnoreCase("-vc"))
					try{
					pc = Integer.parseInt(args[3]);
					}catch(NumberFormatException e){
						System.out.println("chyba argumentu");
					}
			}
			else
			if(args[0].equalsIgnoreCase("-vc")){
				try{
				pc = Integer.parseInt(args[1]);
				}catch(NumberFormatException e){
					System.out.println("chyba argumentu");
				}
				if(args[2].equalsIgnoreCase("-mw"))
					try{
					mw = Integer.parseInt(args[3]);
					}catch(NumberFormatException e){
						System.out.println("chyba argumentu");
					}
			}
		}
		System.out.println("nalezene parametry: mw="+mw+" vc="+pc+" pokud je nulovy, pouzije se preddefinovana hodnota");
		if(mw == 0)
			mw = Program.MW;
		if(pc == 0)
			pc = Program.PC;

		System.out.println("Testování tříd MatrixSearchDynamic a MatrixSearch z programu Program");

		Matrix matice = new Matrix(mw);

     	System.out.println("vzorky původní matice");
		matice.printOutVzorky();
		
		Vzorky mojeVzorky = Vzorky.generateVzorky();
    	System.out.println("Nové vzorky");
		mojeVzorky.printOutVzorce();		

		System.out.println("rozsévání vzorků");
		matice.placeVzorky(pc);
		System.out.println("matice po rozsetí vzorků");
		matice.printOutMatrix();
		/* zmena dynamickeho nebo statickeho prideleni prace */
		MatrixSearchDynamic.searchAndReplace(matice, mojeVzorky);
     	System.out.println("matice po:");
		matice.printOutMatrix();
		/* end of main method */
	}
	/** this method print out help
	 */
	public static void uziti(){
		String napoveda = "program Program slouzi pro testovani tridy MatrixSearch\n"+
									"parametry\n"+
									"\t -mw rozmer generovane matice\n"+
									"\t -vc pocet nahodneho rozmisteni vzorku do matice\n\n"+
									"autor: Robert Smol, predmet PPR, datum 20.11.2002\n";
		System.out.println(napoveda);
	}
}
