package ppr.smol;

import java.io.*;
import java.util.*;

class Vzorky implements Serializable{
	public static int ROZMER =3;
	public static int RAND_MAX = 10;
	int [][] vzorce;
	private int rozmer;
	/**
	 * Constructor for Vzorky
	 */
	Vzorky(){
		this.rozmer = this.ROZMER;
		generateVzorce();
	}
	/**
	 * Constructor for Vzorky with external vzorce.
	 */
	Vzorky(int[][] vzorce) {
		this.rozmer = this.ROZMER;
		this.vzorce = vzorce;
	}
	/** 
	 * returns randomly generated patterns
	 */
	public static Vzorky generateVzorky(){
		Vzorky vzorky = new Vzorky();
	
		return vzorky;
	}
	/**
	 * create random patterns
	 */
	void generateVzorce(){
	Random generator = new Random();
		vzorce = new int[this.rozmer][this.rozmer];
		for(int i = 0; i < this.rozmer; i++){
			for (int j = 0; j < this.rozmer; j++)
				vzorce[i][j] = generator.nextInt(this.RAND_MAX);
		}	
	}
	/**
	 * Returns the vzorce.
	 * @return int[][]
	 */
	public int[][] getVzorce() {
		return vzorce;
	}

	/**
	 * Sets the vzorce.
	 * @param vzorce The vzorce to set
	 */
	public void setVzorce(int[][] vzorce) {
		this.vzorce = vzorce;
	}
	/**
	 * create Matrix from file specified by, filename for read serialized object from file
	 */
	public static Vzorky readVzorce(String filename)  throws IOException,ClassNotFoundException{
		ObjectInputStream  vstup = new ObjectInputStream(new FileInputStream(filename));
		Vzorky returnV = (Vzorky)vstup.readObject();
		
	return returnV;
	}
	/**
	 * Print out obsah of patterns
	 */
	void printOutVzorce(){
	System.out.print("rozmer vzorku: " +this.rozmer);	
	for(int i = 0; i < this.rozmer; i++){
		System.out.println();
			for (int j = 0; j < this.rozmer; j++)
			if (vzorce[i][j] < 10)
				System.out.print(" "+vzorce[i][j]+" ");
			else System.out.print(""+vzorce[i][j]+" ");
		}
		System.out.println();
	}	
	/**
	 * save matrix to file
	 */
	void saveVzorce(String filename) throws IOException{
		ObjectOutputStream vystup = new ObjectOutputStream(new FileOutputStream(filename));
		vystup.writeObject(this);
		vystup.close();		
	}
	/**
	 * Returns the rozmer.
	 * @return int
	 */
	public int getRozmer() {
		return rozmer;
	}

	/**
	 * Sets the rozmer.
	 * @param rozmer The rozmer to set
	 */
	public void setRozmer(int rozmer) {
		this.rozmer = rozmer;
	}
	/**
	 * metoda pro zapsani vozrku jako txt souboru
	 */
	public void toTxt(String filename) {
		
		try {
			PrintWriter tisk = new PrintWriter(
											new BufferedWriter(
											new FileWriter(filename)));
			tisk.println(this.rozmer);
			for(int i = 0; i < this.rozmer ; i++){
				for(int j = 0; j < this.rozmer ; j++){
					tisk.print(this.vzorce[i][j]+"  ");
				}
				tisk.println();
			}
			tisk.close();
		} catch (IOException e) {
			System.out.println("chyba pri otvirani souboru");
		}
	}
}