package cz.zcu.fav.kiv.ppr;

import org.apache.log4j.Logger;

/**
 * PPR1 
 * cz.zcu.fav.kiv.ppr
 * Worker.java
 *
 * @author kablazka
 */
public class Worker extends Thread {
	private static final Logger logger = Logger.getLogger(Worker.class);
	Farmer farmer;
	int id;

	/**
	 * Constructor of the class Worker.java
	 * @param farmer
	 * @param id
	 */
	public Worker(Farmer farmer, int id) {
		this.farmer = farmer;
		this.id = id;
	}
	
	/**
	 * Run method of Worker.
	 */
	public void run() {
		IPieceOfWork data;

		logger.trace(getThreadPrefix() + "is starting ...");

		/**
		 * If is work, take work.
		 */
		while (farmer.waitForWork(id)) {
			//rekne si o praci, data = new PieceOfWork(data,findString,fromLine,toLine)
			data = farmer.getWork();
			
			if (data != null) {
				logger.info(getThreadPrefix()
						+ "gets working on lines: " + (data.getFromLine()+1) + "-"
						+ (data.getToLine()+1) + ".");

				/**
				 * Worker process data, which are given its
				 */
				data.processData();
			
				/**
				 * Return data to Farmer
				 */
				farmer.submitWork(data, id);
			} else {
				logger.trace(getThreadPrefix() + "gets NOOP working peace.");
			}
		}
		logger.trace(getThreadPrefix() + "died!");
	}

	/**
	 * getThreadPrefix
	 * @return ID of thread
	 */
	private String getThreadPrefix() {
		return "Worker No.: " + id + " ";
	}
}
