import java.util.ArrayList;

/**
 * Trida delnika, ktery pracuje
 * @author Pavel
 */
public class WorkingThread extends Thread {
	private Data data;
	private ArrayList<WorkPiece> queue;
	private ArrayList<Integer> polePozic[];
	private ThreadCounter tc;	// citac vlaken

    /**
     * Konstruktor
     * @param tc citac vlaken
     * @param queue fronta pridelovane prace
     * @param data odkaz na data
     * @param polePozic pole se seznamy pozic vysledku
     */
	public WorkingThread(ThreadCounter tc, ArrayList<WorkPiece> queue, Data data, ArrayList<Integer> polePozic[]) {
		this.queue = queue;
		this.polePozic = polePozic;   // pole pro zapisovani vysledku
		this.data = data;
		this.tc = tc;
	}
	
	@Override
	public void run() {
		int odRadku;        // indexy segmentu prace
		int doRadku;
		
		while(true) {
			
			synchronized(this.queue) {			// vlakna jsou synchronizovana na pristupu do fronty
				if (this.queue.size() == 0) {		// fronta se segmenty prace je prazdna
					this.tc.increment();
					break;
				} else {
					WorkPiece wp = this.queue.remove(0);	// ziskame dalsi segment prace
					odRadku = wp.getOdRadku();          // indexy daneho dilu prace
					doRadku = wp.getDoRadku();
				}
			}
		
//			System.out.println("Working on lines " + odRadku + " - " + doRadku);
			data.processFind(odRadku, doRadku, polePozic);	// zpracujeme data, hledame podretezec v zadanych radcich
															// zadani prace jsou 2 indexy do spolecnych dat
		}
	}
	
}
