#include <pvm3.h>
//#include "pvm3.h"
#include <stdlib.h>
#include <string.h>
#include "messages.h"



int pozice[LINES][LINE_LENGTH + 1];  // nalezene pozice, pozice[radek][0] obsahuje vzdy pocet nalezenych pozic, je to kvuli absenci pole.length

/*
 * hleda podretezec v zadanych radkach textu, pocet predanych radek
 * vrati vytvorene pole int hodnot jakozto nalezenych pozic na radce
 * index nalezene_pozice[0] obsahuje pocet nalezenych
 * odkazem take vraci p_pocet nalezenych podretezcu
 */
void hledej_podretezec(int r, char *radek, char *needle) {
  int matched;
  int i, j;
  int pocet = 0;
  
  for (i = 0; i < strlen(radek); i++) {
    matched = 1;
    for (j = 0; j < strlen(needle); j++) {
			if ((i+j) >= strlen(radek)) {	// uz vime ze se slovo nevejde do konce radky
				matched = 0;
				break;
			}
      if (radek[i+j] != needle[j]) {
        matched = 0;       // alespon 1pismenko se neshoduje, nebo uz je konec radku
        break;
      }
    }
    if (matched) {
      pozice[r][pocet + 1] = i;     // pridam nalezenou pozici
      pocet++;
    }
  }

  pozice[r][0] = pocet;     //takova finta, kvuli deb*lnimu cecku, nulty index znamena delku pole
}

/*
 * Prijme od farmare pridelenou praci tj. radek textu a podretezec ke hledani
 * V radku textu hleda podretezec
 * Posle farmarovi vysledky - nalezene pozice podretezce v radku
 * Uvolni po sobe pamet
 */

int main(int argc, char *argv[]) {
  int mytid;
  int delnik_alive = 1;    /* podminka pro ukonceni delnika */
  
  mytid = pvm_mytid();       //prihlaseni do pvm

  pvm_initsend(PvmDataDefault);       //zasleme informaci o tom ze jsme pripraveni
  pvm_send(pvm_parent(), MSG_READY);
  
  while(delnik_alive) {
    if (pvm_nrecv(pvm_parent(), MSG_TODO) > 0) {                //mame praci

      int kolik_radku;          // kolik prijde najednou radku v jednom pracovnim dni
      int od_radku;             // index prvniho radku segmentu do skutecneho indexovani
      char radek[LINE_LENGTH];
      char needle[100];
      
      pvm_upkint(&kolik_radku, 1, 1);         // vime kolik prijde radku
      pvm_upkint(&od_radku, 1, 1);         // index
      pvm_upkstr(needle);                     // naplnime hledany podretezec
      
      int i;

      for (i = 0; i < kolik_radku; i++) {  // prijimam radky
        pvm_upkstr(radek);                      // do radek se naplni prenesenymi daty
        hledej_podretezec(od_radku + i, radek, needle); // hledani, naplnime pole nalezenymi pozicemi
      }
      
      int pocet_nalezeno;
      
      //poslu zpatky vysledky
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&mytid, 1, 1);
      pvm_pkint(&kolik_radku, 1, 1);         // kolik radku bylo zpracovano
      pvm_pkint(&od_radku, 1, 1);         // index

      for (i = 0; i < kolik_radku; i++) {  // odesilam pole s pozicemi
        pocet_nalezeno = pozice[od_radku + i][0];
        pvm_pkint(&pocet_nalezeno, 1, 1);         // kolik nalezeno pozic pro jeden radek
        pvm_pkint(pozice[od_radku + i], pocet_nalezeno + 1, 1);    // pocet je pocet nalezenych podretezcu na radku
        // + 1 protoze nulty index je delka pole
      }
      
      pvm_send(pvm_parent(), MSG_RESULT);
      
    }
    
    //skoncime
    if(pvm_nrecv(pvm_parent(), MSG_QUIT) > 0) {
      delnik_alive = 0;
    }
  }
 
  //pvm_initsend(PvmDataDefault);
  //pvm_send(pvm_parent(),MSG_QUIT);
  
  pvm_exit();
  
  return 0;
}
