/* Semestralni prace z PPR - vyhledani podretezce v retezci pomoci PVM
 *
 * Lukas Mastalir (lumas@students.zcu.cz)
 * 
 * program farmer pousti programy worker na strojich uvedenych v hostfile. 
 * sbira vysledna data od workeru a uklada je do souboru)
 * spousti se : farmer <jmeno souboru> <pocet workeru>
 *                      ^obsahujici retezec pro prohledavani
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pvm3.h>
#include "hlp.h"
#define WORK_NAME "worker" // jmeno spustitelneho souboru workera

int main(int argc, char *argv[]) {
  int mytid, *wtids; //id farmera a pole - tid farmaru
  char *str_in; //vstupni retezec
  char f_str[100];  //hledany retezec
  int delka_in; //delka vstupniho retezce
  int delka_f;  //delka hledaneho retezce
  char *w_arg[5]; // pole argumentu pro workery
  int num_workers=1; // pocet workeru
  int i,delka,odkud,kam,num; //pomocne hodnoty
  int *vystup,*p_hlp; // vystupni pole,pomocny pointer
  int nalezl; // kolik nalezel 1 worker podretezcu
  int nalezeno_celkem; //nalezeno celkem podretezcu
  FILE *fr,*fw;


  // kontrola vstupnich parametru
  if (argc !=3) { 
    printf("Spatne zadane vstupni parametry!\n");
    printf(" pouziti: farmer <jmeno_souboru> <pocet_workeru>\n");    
    exit(1); 
  }
  
  printf("Zadejte hledany retezec: ");
  scanf("%s",f_str);
  delka_f = strlen(f_str);
  if (delka_f < 2) {
    printf("Spatne zadany retezec (velikost min. 2 znaky)!");
    exit(1);
  }
       
  fr=open_f(argv[1],"r"); // otevrit soubor se vstupnimi daty
  str_in = read_file(fr); // nacteni retezce ve kterem se vyhledava
  close_f(fr);
  delka_in = strlen(str_in);
  
  num_workers=atoi(argv[2]);
  num = delka_in / delka_f;
  if (num_workers > num){
    num_workers = num;
    printf("Zadan prilis velky pocet workeru, upravuji pocet na: %d\n\n",num); 
  }

  // alokace pole pro tid workeru
  if((wtids = (int *) malloc(num_workers*sizeof(int))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  // alokace pameti pro parametry workeru
  w_arg[0]=aloc_string(30); //jmeno souboru
  w_arg[1]=aloc_string(20); //odkud
  w_arg[2]=aloc_string(20); //kam 
  w_arg[3]=aloc_string(100);//co
  //ukonceni pole workera
  w_arg[4]=0x00; 

  mytid=pvm_mytid(); // prihlaseni farmera do PVM
  strcpy(w_arg[0],argv[1]); // 1. arg pro delnika (jmeno souboru)
  strcpy(w_arg[3],f_str);   // 4. arg - hledany retezec

  delka = delka_in/num_workers; //delka na ktere bude vyhledavat jeden worker
  odkud = 0;
  kam = odkud + delka + delka_f -3;

  for (i=0; i< num_workers; i++) {
    sprintf(w_arg[1], "%d", odkud);  // 2.arg (odkud bude vyhledavat)

    if (i == (num_workers-1)) {
      //posledni worker hleda az do konce vlakna
      sprintf(w_arg[2], "%d", delka_in-1); // 3.arg (az kam vyhledavat)
    }
    else {  
      sprintf(w_arg[2], "%d", kam); // 3.arg (az kam vyhledavat)
    }  
    if (pvm_spawn(WORK_NAME, w_arg, 0, "", 1, &(wtids[i])) != 1) {
      fprintf(stderr,"pvm_spawn: Task nebyl vytvoren!\n");
      pvm_exit();   
      exit(1);
    }  
    odkud = odkud + delka -1;
    kam = odkud + delka + delka_f -3;
  }

  nalezeno_celkem =0;
  nalezl =0;

  if((vystup = (int *) malloc(sizeof(int))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  //nacteni dat od workeru
  for (i=0; i<num_workers; i++) {
    pvm_recv(wtids[i],MSG_TAG); // blokujici -> ceka na prijem zpravy 
    pvm_upkint(&nalezl, 1, 1); // kolik worker nasel
    if (nalezl != 0) {
      if((vystup = (int *) realloc(vystup,(nalezeno_celkem+nalezl)*sizeof(int)))== NULL) {
        printf("Malo pameti!\n");
        exit(1);
      }
      p_hlp=vystup+nalezeno_celkem;// * sizeof(int); // posun pointeru od posledniho ukladani
      pvm_upkint(p_hlp,nalezl,1); // tolik toho od nej nacti
      nalezeno_celkem+=nalezl;
    }  
  }   

  fw=open_f("find_output.txt","w");
  if (nalezeno_celkem != 0) {
    printf("Pocet nalezenych podretezcu \"%s\"\nv souboru \"%s\" : %d\n\n",f_str,argv[1],nalezeno_celkem);
    printf("Vypis indexu, urcujicich pozice nalezenych podretezcu v retezci:\n");
    fprintf(fw,"Pocet nalezenych podretezcu \"%s\"\nv souboru \"%s\" : %d\n",f_str,argv[1],nalezeno_celkem);
    fprintf(fw,"Vypis indexu, urcujicich pozice nalezenych podretezcu v retezci:\n");

    for(i=0; i<nalezeno_celkem; i++) {
      printf("%d\n", vystup[i]);
      fprintf(fw,"%d\n", vystup[i]);      
    }
  }    
  else {
    printf("Nebyl nalezen zadny vyskyt podretezce: \"%s\"\n",f_str);
    fprintf(fw,"Nebyl nalezen zadny vyskyt podretezce: \"%s\"\n",f_str);    
  }      

  pvm_exit(); // odhlaseni z PVM

  free(w_arg[0]);
  free(w_arg[1]);
  free(w_arg[2]);
  free(w_arg[3]);
  free(str_in);
  free(vystup);
  free(wtids);
   
  return(0);
}

