package cz.keschaf.ppr;

import cz.keschaf.ppr.functions.Function;

public class Data {

	private double sum;

	private double length;

	private double a, b, dx;

	public Data(double a, double b, double dx) {
		super();
		this.a = a;
		this.b = b;
		this.dx = dx;
	}

	public double getSum() {
		return sum;
	}

	public double getLength() {
		return length;
	}

	public synchronized double addSum(double toAdd) {
		this.sum += toAdd;

		return sum;
	}

	private synchronized double addLength(double toAdd) {
		this.length += toAdd;

		return length;
	}

	public double computeMean() {
		return sum / ((b + dx - a) / dx);
	}

	public synchronized void addX(Function f, double x) {
		addSum(f.getResult(x));
		addLength(computeDl(f, x));
	}

	private double computeDl(Function f, double x) {
		return Math.sqrt(Math.pow(dx, 2d) + Math.pow(f.getResult(x + dx) - f.getResult(x),2d));
	}

}