package cz.keschaf.ppr.functions;

/**
 * Tda realizujc vpoet kvadratick funkce y = a * x<sup>2</sup> + b * x + c
 * @author Hrdina Vclav, keschaf@pilsfree.net
 *
 */
public class QuadraticFunction implements Function {

	/**
	 * Koeficient kvadratick funkce.
	 */
	private double a, b, c;
	
	/**
	 * Konstruktor kvadratick funkce.
	 * @param a parametr a kvadratick funkce
	 * @param b parametr b kvadratick funkce
	 * @param c parametr c kvadratick funkce
	 */
	public QuadraticFunction(double a, double b, double c) {
		super();
		if (a == 0d) {
			throw new IllegalArgumentException("a nesmi byt nula");
		}

		this.a = a;
		this.b = b;
		this.c = c;
	}

	public double getResult(double... params) {
		return Math.pow(params[0], 2) * a + params[0] * b + c; 
	}

}
