package ppr.gui;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Font;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;

/**
 * Dialog s vypisem "Pocitam...". 
 *
 */
public class Process extends JDialog {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JLabel jlInfo = null;

	/**
	 * @param owner
	 */
	public Process(JFrame owner) {		
		super(owner);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(280, 140);
		this.setContentPane(getJContentPane());
		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		this.setLocationRelativeTo(null);  // doplneno - centrovani
		this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		this.setTitle("Stav");
		this.setModal(true);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jlInfo = new JLabel();
			jlInfo.setText("");
			jlInfo.setHorizontalTextPosition(SwingConstants.CENTER);
			jlInfo.setHorizontalAlignment(SwingConstants.CENTER);
			jlInfo.setFont(new Font("Dialog", Font.BOLD, 20));
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(jlInfo, BorderLayout.CENTER);
		}
		return jContentPane;
	}
	
	/**
	 * Vypise text do dialogu.
	 * @param string text
	 */
	public void print(String string) {		
		jlInfo.setText(string);
		this.repaint();
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
