#include <stdlib.h>
#include <stdio.h>
#include <pvm3.h>

#include "def.h"

T_POINT point;  // krajni bod kvadru
float d;   //  diference
int count_workers; // pocet delniku
float part;  // cast prace pridelena delikovi
int fnc; // funkce hustoty

float counted_work = 0;

int working = 0;

int mytid;  // identifikator procesu

void print_help() {
	printf("Popis formt pkazu pro sputn programu:\n\n");
	printf("Worker: \n");
	printf("\tworker\n\n\n");
	printf("Farmer: \n");
	printf("\farmer <pocet vl.> <velikost prace> <x> <y> <z> <d> <funkce hustoty>\n");
	printf("Formt parametr:\n");
	printf("\t<pocet vl.>       - poet vlken - musi byt > 0\n");
	printf("\t<velikost prace>  - velikost kusu prce pidlen vlknu z intervalu (0;100>\n");
	printf("\t<x> <y> <z>       - definice kvdru\n");
	printf("\t<d>               - integran krok (stejny pro vsechny osy) - musi platit d > 0\n");
	printf("\t<funkce>          - \n");
	printf("\t\t1:              - 1\n");		
	printf("\t\t2:              - x\n");
	printf("\t\t3:              - x + y + z\n\n");
	printf("Pklad sputn programu s parametry:\n");
	printf("\tfarmer 10 0.1 1.0 1.0 1.0 0.1 1\n");
} 

void set_work(int tid) {
	if ((counted_work + part) <= 100.0) {
		float start_x = point.x * (counted_work / (float) 100);
        float start_y = 0.0;
        float start_z = 0.0;

		counted_work += part;

        float end_x = point.x * (counted_work / (float) 100);
        float end_y = point.y;
        float end_z = point.z;
            
            // prideleni prace delnikovi
        pvm_initsend(PvmDataDefault);   // inicializace bufferu
        pvm_pkfloat(&start_x, 1, 1);
        pvm_pkfloat(&start_y, 1, 1);
        pvm_pkfloat(&start_z, 1, 1);
        pvm_pkfloat(&end_x, 1, 1);
        pvm_pkfloat(&end_y, 1, 1);
        pvm_pkfloat(&end_z, 1, 1);
        pvm_pkfloat(&d, 1, 1);
        pvm_pkint(&fnc, 1, 1);
        pvm_send(tid, STATE_WORK);
		working++;
	} 
	else {
		if (counted_work >= 100.0)
			return;

        float start_x = point.x * (counted_work * (float) 100);
        float start_y = 0.0;
        float start_z = 0.0;

		counted_work = 100;

        float end_x = point.x;
        float end_y = point.y;
        float end_z = point.z;
            
        /* Zaslani prace workerovi */
        pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
        pvm_pkfloat(&start_x, 1, 1);
        pvm_pkfloat(&start_y, 1, 1);
        pvm_pkfloat(&start_z, 1, 1);
        pvm_pkfloat(&end_x, 1, 1);
        pvm_pkfloat(&end_y, 1, 1);
        pvm_pkfloat(&end_z, 1, 1);
        pvm_pkfloat(&d, 1, 1);
        pvm_pkint(&fnc, 1, 1);
        pvm_send(tid, STATE_WORK);
		working++;
    }        
}

int main(int argc, char *argv[]) {
	int tids[32];       // identifikatory procesu
    int* tidc;          // pomocny ukazatel pro vytvareni delniku
    int create_workers = 0;    // pocet vytvorenych workeru
    int tid;            // pomocny identifikator procesu
    

	float weight = 0, total_weight = 0;

	int i;

	printf("Vpoet hmotnosti kvdru\n");
	printf("------------------------\n");
	printf("Semestrln prce z pedmtu KIV/PPR\n\n");
	printf("\tAutor:     Vt Lachner\n");
	printf("\tSt. slo: A06093\n");
	printf("\tE-mail:    lachner@students.zcu.cz\n\n\n");

	if (argc == 8) {
		count_workers = atoi(argv[1]);
		part = atof(argv[2]);
		point.x = atof(argv[3]);
		point.y = atof(argv[4]);
		point.z = atof(argv[5]);
		d = atof(argv[6]);
		fnc = atoi(argv[7]);

		if ((count_workers <= 0) ||
			(part <= 0) ||
			(part > 100) ||
			(d <= 0) ||
			(fnc < 0) ||
			(fnc > 3)) {
			printf("chybne parametry\n");
			return;
		}
	}
	else {
        print_help();
		return 0;
	}

	mytid = pvm_mytid();
	
	tidc = tids;

	// vytvareni delniku
    while (count_workers > create_workers) {
        if (pvm_spawn("worker", (char**)0, 0, "", 1, tidc)) {  // vytvoreni delnika
            create_workers++;
            tidc++;
        } 
		else {  // neuspesne vytvoreni delnika
            printf("chyba %d pri vytvareni delnika.", *tidc);
        }
    }

	// uvodni komunikace farmare s workery
	pvm_initsend(PvmDataDefault);   			// inicializace bufferu
	pvm_pkint(&mytid, 1, 1);    				// ulozeni identifikace
	pvm_mcast(tids, count_workers, STATE_REG);  // broadcast zpravy

	// cekani na zpravu STATE_READY
	for(i = 0; i < count_workers; i++) { 
        pvm_recv(-1, STATE_READY);		// delnik jse pripraven
        pvm_upkint(&tid, 1, 1);         // id delnika
    }

	for (i = 0; i < count_workers; i++) {
        set_work(tids[i]);
    }
	
    while (working != 0) {
        if (pvm_nrecv(-1, STATE_COUNTED) > 0) {
            pvm_upkint(&tid, 1, 1);
            pvm_upkfloat(&weight, 1, 1);

			--working;

            total_weight += weight;

            set_work(tid);  // zadani prace
        }
    } 

    pvm_mcast(tids, count_workers, STATE_DIE);  // ukonceni delniku

    // cekani na ukonceni delniku
    for(i = 0; i < count_workers; i++) { 
        pvm_recv(-1, STATE_DIE);        // delnik
        pvm_upkint(&tid, 1, 1);         // id delnika
    } 

    // ukonceni PVM
    pvm_exit();
    
    // tisk vysledku
    printf("\nhmotnost kvadru: %.10f\n", total_weight);

	return 0;
}
