#include <pvm3.h>

#include "def.h"

int mytid;      /* Identifikator delnika */
int farmer_tid;  /*  identifikator procesu sef  */

float fnc_ro(float x, float y, float z, int fnc) 
{
    switch (fnc) {
        case (FNC_CONSTANT):
            return 1;
        case (FNC_X):
            return x;
        case (FNC_XYZ):
            return x + y + z;
        default:
            return 0;
    }
}

float count_weight(float start_x, float start_y, float start_z, float end_x, float end_y, float end_z, float d, int fnc)
{
    float x, y, z;
    float weight = 0;    

	for (x = start_x; x < end_x; x += d) {
		for (y = start_y; y < end_y; y += d) {
			for (z = start_z; z < end_z; z += d) {
				float mX = x;
				float mY = y;
				float mZ = z;
							
				float dX = d;
				float dY = d;
				float dZ = d;
							
				// osetreni pripadu, pokud je soucasna pozice + integracni krok vetsi nez okraj zadaneho vypoctu														
				if  ((x + d) > end_x)
					dX = mX = end_x - x;
														
				if  ((y + d) > end_y)								
					dY = mY = end_y - y;
								 							
				if  ((z + d) > end_z)								 
					dZ = mZ = end_z - z;
												
				// vypocet vahy
				weight += dX * dY * dZ * fnc_ro(mX + dX / (float) 2, mY + dY / (float) 2, mZ + dZ / (float) 2, fnc);
			}	
		}
	}
   
	return weight;
}

main(int argc, char *argv[]) {	
    mytid = pvm_mytid();	 // prihlaseni do pvm

    pvm_recv(-1, STATE_REG);		// prijeti zpravy s registraci
    pvm_upkint(&farmer_tid, 1, 1);	// cislo farmera

	if (farmer_tid == pvm_parent()) {
        pvm_initsend(PvmDataDefault);		// inicializace bufferu
        pvm_pkint(&mytid, 1, 1);			// ulozeni identifikace
        pvm_send(farmer_tid, STATE_READY);	// potvrzeni pripravenosti
    }

	while (1) {    
        if (pvm_nrecv(farmer_tid, STATE_WORK) > 0) {  // pridelena prace
            float start_x, start_y, start_z, end_x, end_y, end_z, d, weight;
            int fnc;
            
			// prijeti 
            pvm_upkfloat(&start_x, 1, 1);
            pvm_upkfloat(&start_y, 1, 1);
            pvm_upkfloat(&start_z, 1, 1);
            pvm_upkfloat(&end_x, 1, 1);
            pvm_upkfloat(&end_y, 1, 1);
            pvm_upkfloat(&end_z, 1, 1);
            pvm_upkfloat(&d, 1, 1);
            pvm_upkint(&fnc, 1, 1);            
                        
            weight = count_weight(start_x, start_y, start_z, end_x, end_y, end_z, d, fnc);
    
			// odeslani vysledku
            pvm_initsend(PvmDataDefault); // inicializace bufferu
            pvm_pkint(&mytid, 1, 1);
            pvm_pkfloat(&weight, 1, 1);  // vysledek
            pvm_send(farmer_tid, STATE_COUNTED);
        }
		else if (pvm_nrecv(farmer_tid, STATE_DIE) > 0) {  // ukonceni workera
            pvm_pkint(&mytid, 1, 1);             // ulozeni identifikace
			pvm_send(farmer_tid, STATE_DIE);      // potvrzeni ukonceni
 
			pvm_exit();  // ukonceni PVM
			return 0;  
		}
    }
    
    return 0;  
}
