/*
 * prace:             semestralni samostatna prace z paralelniho programovani
 *                    cast 2: paralelni program pro system s distribuovanou pameti (PVM)
 * autor:             Josef Mlnarik
 * student id:        A00141
 * datum narozeni:    31.10.1981
 * datum vypracovani: leden 2006 
 * predmet:           KIV/PPR
 * cislo zadani:      1 = (31 + 10) % 20
 * formulace zadani:  realizujte vypocet nejmensiho/nejvetsiho prvku ctvercove matice
 *                    s kladnymi celociselnymi prvky a konverze (mormalizace) na realnou
 *                    matici s prvky v intervalu <0,1>
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "help.h"

int N;															/* rozmer matice */

// nacte vstupni matici ze souboru
double **nactiMatici(FILE *fr){
	int i=0,j=0;												/* pomocne promenne */
	double **matice,buff;										/* matice, buffer*/
	
	while (fscanf(fr,"%lf",&buff) != EOF) i++;					/* nacita ze souboru floaty po jednom do bufferu */
	fseek(fr,SEEK_SET,0);
	N=(int)sqrt(i);												/* kontrola: druha mocnina rozmeru ctvercove matice = pocet jejich prvku */
	if (N*N != i) {												/* pokud neplati, tak nemame nactenou korektni matici */
		printf("chyba: nespravna data ve vstupnim souboru\n");	/* upozorneni */
		zavriSoubor(fr);										/* zavre soubor */
		exit( 0);												/* konec */
	}
	matice=alokujMatici();										/* pokud v poradku, tak alokuj pamet pro matici */
	i=0;
	while (fscanf(fr,"%lf",&buff) != EOF) {						/* nacti ze souboru floaty po jednom do bufferu */
		matice[i][j]=buff;										/* buffer prekopiruj do matice */
		j++;													/* dalsi prvek matice */
		if (j==(N)) { 											/* dalsi radek matice */
			j=0; 
			i++;
		}
	}
	zavriSoubor(fr);											/* zavre soubor */										
	return matice;												/* vrati nactenou matici */
}

// vypise matici
int vypisMatici(double **matice, int par){
	int i,j;													/* pomocne promenne */
	
	for (i=0;i<N;i++){											/* pro kazdy radek */
		for (j=0;j<N;j++){										/* pro kazdy prvek radku */
			par == 0 ? printf("%3.0f ",matice[i][j]) : printf("%1.3f ",matice[i][j]);
		}														/* vypis prvek formatovany bud pro vstupni nebo vystupni matici */
		printf("\n");											/* novy radek */
	}
	return 1;													/* konec */
}

// alokuje pamet pro matici
double **alokujMatici(void){
	double **matice;											/* matice */
	int i;														/* pomocna promenna */

	matice=(double **)malloc(N*sizeof(double));					/* alokace pameti */
	for (i=0;i<N;i++)
		matice[i]=(double *)malloc(N*sizeof(double));
	return (matice);											/* vrati matici */
}

// funkce pro otevreni souboru
FILE *otevriSoubor(char *name, const char *mod){ 
	FILE *f;													/* soubor */
	
	if ((f=fopen(name,mod)) == NULL) {							/* otevreni souboru */
		fprintf(stderr,"chyba: soubor %s nelze otevrit\n",name);/* s testem uspesnosti */
		exit(1);
	}     	
	return(f);													/* vrati ukazatel na soubor */
}

// funkce pro zavreni souboru
void zavriSoubor(FILE *file){
	if (fclose(file) == EOF) {									/* zavreni souboru */
		fprintf(stderr,"chyba: soubor nelze zavrit\n");			/* s testem uspesnosti */
		exit(1);
	}    
}

