/*
 * prace:             semestralni samostatna prace z paralelniho programovani
 *                    cast 2: paralelni program pro system s distribuovanou pameti (PVM)
 * autor:             Josef Mlnarik
 * student id:        A00141
 * datum narozeni:    31.10.1981
 * datum vypracovani: leden 2006 
 * predmet:           KIV/PPR
 * cislo zadani:      1 = (31 + 10) % 20
 * formulace zadani:  realizujte vypocet nejmensiho/nejvetsiho prvku ctvercove matice
 *                    s kladnymi celociselnymi prvky a konverze (mormalizace) na realnou
 *                    matici s prvky v intervalu <0,1>
 */
 
#include "pvm3.h"
#include <stdio.h>

main() {
	int mytid;      									/* identifikator procesu delnik */
	int chief_tid;  									/* identifikator procesu sef */
	int i;          									/* pomocna promenna */
	double* radka;										/* zpracovavany radek */
	int rozmer;											/* delka zpracovavaneho radku = rozmer matice */
	double nejvetsi = -1;								/* nejvetsi prvek radku = delnika */
	double nejmensi = -1;								/* nejmensi prvek radku = delnika */
	int radek = 0;										/* cislo zpracovavaneho radku */
  
  	// prihlaseni do PVM
	mytid = pvm_mytid();  								/* prirazeni identifikatoru */

	// cekani na zpravu od sefa
	pvm_recv(-1, 4);               						/* kod zpravy 4:broadcast(id sefa->delnici)*/
	pvm_upkint(&chief_tid, 1, 1);  						/* zjisti cislo sefa */  
    
	// odpoved sefovi
	if (chief_tid == pvm_parent()) {					/* kontrola zda je sef ten pravy - totozny s otcem */
    	pvm_initsend(PvmDataDefault);					/* inicializace bufferu */
		pvm_pkint(&mytid, 1, 1);    					/* ulozeni identifikace */
		pvm_send(chief_tid, 5);     					/* kod zpravy 5:odpoved(id delnika->sef) */
	}

  	// delnik bude hledat extremy ve svem radku
    pvm_recv (chief_tid, 6);   							/* cteni  prikazu */
    pvm_upkint(&rozmer, 1, 1);							/* ziska rozmer */
    radka = (double *)malloc (rozmer*sizeof(double));	/* alokace pameti pro radku */
    pvm_upkdouble (radka, rozmer, 1); 					/* ziska radku */
    pvm_upkint(&radek, 1, 1);							/* ziska cislo radky */
    
    // nalezeni nejvetsiho/nejmensiho prvku radku
    nejvetsi = nejmensi = radka[0];						/* na zacatku je prvni nejmensim i nejvetsim */
    for (i=0; i<rozmer; i++) {
		nejvetsi = (radka[i] > nejvetsi ? radka[i] : nejvetsi);
		nejmensi = (radka[i] < nejmensi ? radka[i] : nejmensi);
    }

	// odeslani vysledku
    pvm_initsend(PvmDataDefault);						/* inicializace bufferu */
    pvm_pkint(&mytid, 1, 1);     						/* ulozeni identifikace */
    pvm_pkdouble(&nejvetsi, 1, 1);     					/* ulozeni nejvetsiho */
    pvm_pkdouble(&nejmensi, 1, 1);  					/* ulozeni nejmensiho */
    pvm_send(chief_tid, 7);      						/* zprava s kodem 7:vysledek(delnik->sef) */

  	// delnik bude normalizovat svuj radek    
    pvm_recv (chief_tid, 6);   							/* cteni zpravy s kodem 6:zadani ukolu(sef->delnik) */
    pvm_upkdouble(&nejvetsi, 1, 1);						/* ziska nejvetsi */
    
    // normalizace sveho radku
    for (i=0; i<rozmer; i++) {
		radka[i] = radka[i]/nejvetsi;
    }

	// odeslani vysledku a ukonceni delnika
    pvm_initsend(PvmDataDefault);						/* inicializace bufferu */
    pvm_pkint(&mytid, 1, 1);    						/* ulozeni ukoncovaci zpravy */
    pvm_pkdouble(radka, rozmer, 1);    					/* ulozeni radku */
    pvm_pkint(&radek, 1, 1); 							/* ulozeni cisla radku */
    pvm_send(chief_tid, 7);                     		/* zprava s kodem 7:vysledek(delnik->sef) */

	pvm_exit();											/* ukonceni cinnosti */
}

