package Naboj;

import java.util.*;

/**
 * <p>Title: Vpoet intenzity pole pomoc vlken</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Martin Podval
 * @version 1.0
 */

public class Model {
  private Naboj naboj;
  private Plocha plocha;
  public final double epsilon = 12.556e-7;
  private double epsilon_r;
  private int pocetProcesu;
  private long casBehu;

  public Model(Naboj naboj, Plocha plocha, double epsilon_r, int pocetProcesu) {
    this.naboj = naboj;
    this.plocha = plocha;
    this.epsilon_r = epsilon_r;
    this.pocetProcesu = pocetProcesu;
  }

  public double GetEpsilon_r(){
    return this.epsilon_r;
  }

  /**
   * Provede vypocet pomoci vlaken
   */
  public void vypocti(){
    boolean x = true;
    int pocetPolozek = 0;
    Delnik[] delnici;

    ArrayList[] seznamySloupcu = new ArrayList[this.pocetProcesu]; // Pro kazdy proces ulozi seznam sloupcu, ktere ma vypocitat
    for(int i=0; i < this.pocetProcesu; i++) seznamySloupcu[i] = new ArrayList();


    // Zjistime, ktera strana je delsi - proto abychom vzdy delali mensi pocet vlaken
    if(this.plocha.GetRozmer().GetX() < this.plocha.GetRozmer().GetY()){
      int vlakno = 0;

      for(int i=0; i < this.plocha.GetRozmer().GetY(); i++){
        seznamySloupcu[vlakno].add(new Integer(i));

        // Inkrementujeme promennou udavajici, ktere vlakno to ma pocitat
        if(vlakno  == (this.pocetProcesu-1)) vlakno=0;
        else vlakno ++;
      }
      x = false;
      pocetPolozek = this.plocha.GetRozmer().GetX();       // pocet polozek pro kazdou radu
    }
    else {
      int vlakno = 0;
      for (int i = 0; i < this.plocha.GetRozmer().GetX(); i++) {
        seznamySloupcu[vlakno].add(new Integer(i));

        // Inkrementujeme promennou udavajici, ktere vlakno to ma pocitat
        if (vlakno == (this.pocetProcesu - 1))
          vlakno = 0;
        else
          vlakno++;
      }
      x = true;
      pocetPolozek = this.plocha.GetRozmer().GetY();       // pocet polozek pro kazdou radu
    }

    // Zacatek behu vlaken
    Date zacatek = new Date();
    casBehu = zacatek.getTime();

    delnici = new Delnik[this.pocetProcesu];
    for(int i=0; i < this.pocetProcesu; i++){

      delnici[i] = new Delnik(
          this,
          seznamySloupcu[i],
          pocetPolozek,
          x);

      delnici[i].start();
      System.out.println("Vlkno slo " + (i+1) + " sputno");
    }

    // Pockame az to dojede
    try{
      for (int i = 0; i < delnici.length; i++){
        delnici[i].join();
        System.out.println("Vlkno slo " + (i+1) + " ukoneno");
      }
    }
    catch(InterruptedException e){
      e.printStackTrace();
    }

    // Zacatek behu vlaken
    Date konec = new Date();
    casBehu = konec.getTime() - casBehu;

    System.out.println("\nas bhu vpotu: " + casBehu);
  }

  public Naboj GetNaboj(){
    return this.naboj;
  }

  public Plocha GetPlocha(){
    return this.plocha;
  }

  public void VypisVysledky(){
    TextExport te = new TextExport(this);
    te.UlozData();

//    double[][] intenzity = this.plocha.GetIntenzity();

//    for(int i = 0; i < intenzity.length; i++){
//      for(int j = 0; j < intenzity[i].length; j++) System.out.print(intenzity[i][j] + " ");
//      System.out.println();
//    }
  }

  public int GetPocetProcesu(){
    return this.pocetProcesu;
  }

  public long GetCasBehu(){
    return this.casBehu;
  }
}