package Naboj;

import java.io.*;
import java.util.*;
import java.text.*;

/**
 * <p>Title: Vpoet intenzity pole pomoc vlken</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Martin Podval
 * @version 1.0
 */

public class TextExport {
  private Model model;

  public TextExport(Model model) {
    this.model = model;
  }

  public void UlozData(){
    Calendar calendar = new GregorianCalendar();

    try{
      NumberFormat nfd = NumberFormat.getInstance();
      nfd.setMinimumIntegerDigits(2);

      File f = new File("vypisy/hodnoty" + calendar.get(calendar.YEAR) + nfd.format(calendar.get(calendar.MONTH) + 1) + nfd.format(calendar.get(calendar.DAY_OF_MONTH)) + nfd.format(calendar.get(calendar.SECOND)) + nfd.format(calendar.get(calendar.MINUTE)) + nfd.format(calendar.get(calendar.HOUR)) + ".html");
      FileWriter fw = new FileWriter(f, false);
      BufferedWriter bw = new BufferedWriter(fw);

      // Hlavicka stranky
      bw.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n" +
              "<html lang=\"cs\">\n" +
              "<head>\n" +
              "<meta http-equiv=\"Content-Language\" content=\"cs\">\n" +
              "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1250\">\n" +
              "<title>Vsledky vpotu hodnot intenzit - " +
              calendar.get(calendar.HOUR) + ":" + nfd.format(calendar.get(calendar.MINUTE)) + ":" + nfd.format(calendar.get(calendar.SECOND)) + " " +
              calendar.get(calendar.DAY_OF_MONTH) + "." + (calendar.get(calendar.MONTH) + 1) + "." + calendar.get(calendar.YEAR) +
              "</title>\n" +
              "<link rel=\"StyleSheet\" href=\"styl.css\" TYPE=\"text/css\">" +
              "</head>\n" +
              "<body>\n"
              );

     bw.write("<div class=\"nadpis\">Vstupn hodnoty</div>\n<br/>");
     bw.write("<span class=\"parametry\">Souadnice nboje:</span><span class=\"hodnoty\"> [" + this.model.GetNaboj().GetSouradnice().GetX() + ", " + this.model.GetNaboj().GetSouradnice().GetY() + ", " + this.model.GetNaboj().GetSouradnice().GetZ() + "]</span><br/>\n");
     bw.write("<span class=\"parametry\">Hodnota nboje:</span><span class=\"hodnoty\"> " + this.model.GetNaboj().GetNaboj() + "C</span><br/>\n");
     bw.write("<span class=\"parametry\">Velikost plochy:</span><span class=\"hodnoty\"> " + this.model.GetPlocha().GetRozmer().GetX() + "x" + this.model.GetPlocha().GetRozmer().GetY() + "</span><br/>\n");
     bw.write("<span class=\"parametry\">Relativn permeabilita:</span><span class=\"hodnoty\"> " + this.model.GetEpsilon_r() + "</span><br/>\n");
     bw.write("<span class=\"parametry\">Poet proces:</span><span class=\"hodnoty\"> " + this.model.GetPocetProcesu() + "</span><br/><br/>\n");

     bw.write("<div class=\"nadpis\">Vsledky</div>\n<br/>");
     bw.write("<span class=\"parametry\">as bhu programu:</span><span class=\"hodnoty\"> " + this.model.GetCasBehu() + " ms</span><br/>\n");
     bw.write("<br/>\n");

     bw.write("<table cellpadding=\"2\">\n");
     bw.write("<tr align=\"center\">\n<td>Y\\X</td>\n");

     NumberFormat nf = NumberFormat.getInstance();
     nf.setMaximumFractionDigits(2);

     double intenzity[][] = this.model.GetPlocha().GetIntenzity();
     Vektor smery[][] = this.model.GetPlocha().GetSmery();

     for(int i = 0; i < intenzity.length; i++){
       bw.write("<td><span class=\"souradnice\">" + (i+1) + "</span></td>\n");
     }

     bw.write("</tr>\n");

     for(int j = 0; j < intenzity[0].length; j++){
       bw.write("<tr align=\"center\">\n");
       for(int i=0; i <= intenzity.length; i++){
         if(i==0) bw.write("<td><span class=\"souradnice\">" + (j+1) + "</span></td>\n");
         else bw.write("<td width=\"100\"><span class=\"data\">" + nf.format(intenzity[i-1][j]) + "</span><br/>" +
                       "<span class=\"smery\">[" + smery[i-1][j].GetX() + ",&nbsp;" + smery[i-1][j].GetY() + ",&nbsp;" + smery[i-1][j].GetZ() + "]</span></td>\n");
       }
       bw.write("</tr>\n");
     }

     bw.write("</table>\n");

     // Footer stranky
     bw.write("</body>\n</html>");

     bw.close();
     fw.close();
    }
    catch(IOException e){
      System.out.println("Vstupn soubor nelze otevt pro zpis");
    }
  }

}