package ppr;

import java.io.IOException;
import java.util.ArrayList;
import ppr.image.Bitmap;
import ppr.threading.ThreadCounter;
import ppr.threading.WorkingThread;

public class Negative {
	private ArrayList<Integer> queue;
	
//	private int threadNo;
//	private int pixels;
//	private int k;
//	private String originalBmp;
//	private String negativeBmp;
	
	public Negative(){
		this.queue = new ArrayList<Integer>();
	}
//	public Negative(int threadNo,int pixels,int k,String original,String negative){
//		this.queue = new ArrayList<Integer>();
//		
////		this.threadNo = threadNo;
////		this.pixels = pixels;
////		this.k = k;
////		this.originalBmp = original;
////		this.negativeBmp = negative;
//	}
	
	public void transform(int threads,int pixels,int k,String bitmap,String negative){
		try {
			Bitmap bmp = new Bitmap(bitmap);
			if(bmp.checkBitmap() == false){
				System.err.println("Vstupni obrazek neni bitmapa nebo nema spravny format.");
				System.err.println("Aplikace akceptuje pouze nekomprimovany truecolor bitmapy.");
				return;
			}
			//load bitmap
			byte[][] data = bmp.loadData(pixels);
			//prepare queue
			for(int i = 0; i < data.length; i++)
				this.queue.add(i);
			
			//start all threads
			ThreadCounter tc = new ThreadCounter(threads);
			for(int i = 0; i < threads ; i++){
				new WorkingThread(this.queue,data,k,tc).start();
			}
			
			//wait till all threads complete
			tc.waitForAll();
			
			//save transformed bitmap
			bmp.saveBitmap(negative, data);
			bmp.close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static void printInfo(){
		System.out.println();
		System.out.println("Vytvoreni negativu k puvodnimu obrazku");
		System.out.println("======================================");
		System.out.println();
		System.out.println("Semestralni prace na PPR");
		System.out.println("Milan Balcar\tA06072");
		System.out.println();
		System.out.println("Aplikaci je nunto spoustet s 5 parametry.");
		System.out.println();
		System.out.println("java ppr.Negative <pocet vlaken> <velikost prace> <k> <vstupni soubor> <vystupni soubor>");
		System.out.println("   <pocet vlaken>      - pocet vlaken, v kterych vypocet pobezi");
		System.out.println("   <velikost prace>    - pocet pixelu, ktera ma jedno vlakno zpracovat");
		System.out.println("   <k>                 - jas pixelu v rozsaho <0;255>");
		System.out.println("   <vstupni soubor>    - bitmapa s obrazkem");
		System.out.println("   <vystupni soubor>   - vysledek bude ulozen do tohoto souboru");
		
	}
	
	public static void main(String[] args) {
		if(args.length != 5){
			System.err.println("Nespravny pocet argumentu.");
			Negative.printInfo();
			return;
		}
		
		try {
			int threads = Integer.parseInt(args[0]);
			int pixels = Integer.parseInt(args[1]);
			int k = Integer.parseInt(args[2]);
			
			if(threads <= 0 || pixels <= 0 || k < 0 || k > 255)
				throw new NumberFormatException();
			
			//Negative n = new Negative(threads,pixels,k,args[2],args[3]);
			Negative n = new Negative();
			
			long time = System.currentTimeMillis();
			n.transform(threads,pixels,k,args[3],args[4]);
			System.out.println(System.currentTimeMillis() - time + " ms");
		} catch (NumberFormatException e) {
			System.err.println("Pocet vlaken a velikost prace musi byt vetsi jak 0, velikost k musi byt v rozsahu <0;255>.");
		}
	}
}
