#include <stdlib.h>
#include <pvm3.h>
#include "ppr.h"
/*
 *Projde pole a podle vzorce upravi vsechny hodnoty
 * new(x,y) = k - old(x,y)
 */
void zpracuj(byte * data, int k, int data_len){
    int i = 0;
    
    for(i = 0; i < data_len; i++ ){
        data[i] = (k-data[i] < 0)? 0:k-data[i];
    }
}

/*
 * Nacte prijata data z bufferu a preda je funkci na zpracovani negativu.
 * Upravene pole hodnot posle rodicovi zpatky.
 * A smaze veskerou pridelenou pamet.
 */
void processData(int mytid){
    int pixels, k, index;
    byte * data;
    
    pvm_upkint(&index, 1, 1);
    pvm_upkint(&pixels, 1, 1);
    pvm_upkint(&k, 1, 1);
    data = (byte *)malloc(pixels*BYTES_PER_PIXEL*sizeof(byte));
    pvm_upkbyte(data, pixels*BYTES_PER_PIXEL, 1);
    
    //zpracuju pole
    zpracuj(data, k, pixels*BYTES_PER_PIXEL);
    
    //poslu zpatky
    pvm_initsend(PvmDataDefault);
    pvm_pkint(&mytid, 1, 1);
    pvm_pkint(&index, 1, 1);
    pvm_pkbyte(data, pixels*BYTES_PER_PIXEL, 1);
    pvm_send(pvm_parent(), MSG_RESULT);
    
    //uvolnim alokovanou pamet
    free(data);
    data = 0;
}

int main(int argc, char ** argv){
    
    int mytid;
    
    //prihlaseni do pvm
    mytid = pvm_mytid();
    //zasleme informaci o tom ze jsme pripraveni
    pvm_initsend(PvmDataDefault);
    pvm_send(pvm_parent(), MSG_READY);
    
    while(1){
        //mame praci
        if(pvm_nrecv(pvm_parent(), MSG_TODO) > 0){
            processData(mytid);
        }
        
        //skoncime
        if(pvm_nrecv(pvm_parent(), MSG_QUIT) > 0){
            break;
        }
    }
    
    //odesleme potvrzeni o ukonceni
    //pvm_initsend(PvmDataDefault);
    //pvm_send(pvm_parent(),MSG_QUIT);
    
    pvm_exit();
    
    return 0;
}
