package info.exac.ppr;


public class HmotnostThread extends Thread {

	public static boolean DEBUG = false;
	
	public static int STAV_VYTVORENE = 1;
	public static int STAV_NASTAVENE = 2;
	public static int STAV_POCITAJICI = 3;
	public static int STAV_VYPOCTENE = 4;
	public static int STAV_UMIRAJICI = 5;
	

	
	private int stav = 0;
	private int prubeh = 0;
	private long iterace = 0;
	
	private double startX = 0;
	private double startY = 0;
	private double startZ = 0;

	private double konecX = 0;
	private double konecY = 0;
	private double konecZ = 0;
	
	private double d = 0; 
	
	private FunkceRo funkceRo = null;
	
	private double hmotnost = 0;
	
	
	
	
	public HmotnostThread() {
		super();
		stav = STAV_VYTVORENE;
		if (DEBUG) System.out.println("Vlakno " + getId() + ": Vytvoreno");
	}

	
	public void setDebugMode() {
		DEBUG = true;
	}
	
	public void setNormalMode() {
		DEBUG = false;
	}
	
	public void nastavVypocet(double startX, double startY, double startZ, double konecX, double konecY, double konecZ, double d, int jakaFunkce) {
		
		this.startX = startX;
		this.startY = startY;
		this.startZ = startZ;
		
		this.konecX = konecX;
		this.konecY = konecY;
		this.konecZ = konecZ;
		
		this.d = d;
		
		this.funkceRo = new FunkceRo(jakaFunkce);
		
		this.hmotnost = 0;
		
		this.stav = STAV_NASTAVENE;

		if (DEBUG) System.out.println("Vlakno " + getId() + ": Nastaveno");
	}
	
	
	
	public void vypocti() {
		stav = STAV_POCITAJICI;
		prubeh = 0;
	}
	
	
	
	public void umri() {
		if (DEBUG) System.out.println("Vlakno " + getId() + ": Zabijim se");
		stav = STAV_UMIRAJICI;
	}
	
	
	
	public double getHmotnost() {
		return hmotnost;
	}
	
	
	public int getStav() {
		return stav;
	}
	
	public int getPrubeh() {
		return prubeh;
	}
	
	
	
	public void vytiskni() {
		
		System.out.println("Vlakno " + getId() + ":\tprubeh " + prubeh + "%\t m = " + hmotnost + "\t" + getState() + "(" + getStav() + ")");
	}
	
	
	
	private void vypocet() {

		iterace = 0;
		
		if (DEBUG) System.out.println("Vlakno " + getId() + ": Zacatek vypoctu");
		
		for (double x = startX; x < konecX; x += d ) {
			for (double y = startY; y < konecY; y += d ) {
				for (double z = startZ; z < konecZ; z += d ) {
				
					double dM = d * d * d * funkceRo.getRo(x + d/2, y + d/2, z + d/2);
					this.hmotnost += dM;
					
					iterace++;				}
			}
			prubeh = (int) (  (x - startX) / ((konecX - startX) / 100)  ) ;
		}
		
		prubeh = 100;
		stav = STAV_VYPOCTENE;
		if (DEBUG) System.out.println("Vlakno " + getId() + ": Konec vypoctu (iteraci " + iterace +")");
	}

	
	public void run() {
		
		if (DEBUG) System.out.println("Vlakno " + getId() + ": Start pracovni smycky");
		
		/* Temer nekonecna smycka */
		while (stav != STAV_UMIRAJICI) {
			
			if (stav == STAV_POCITAJICI) {
				vypocet();
			}
			
		}
//		System.out.println( this.getId() + ": Umiram");

		if (DEBUG) System.out.println("Vlakno " + getId() + ": Konec smycky, konec vlakna");
	}
	
}
