/* ========================================================================== */
/*                                                                            */
/*   exac-main.c                                                              */
/*   (c) 2007 Miroslav 'Exac' Exner                                           */ 
/*                                                                            */
/*   Hlavni modul s funkci main()                                             */
/*                                                                            */
/* ========================================================================== */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <pvm3.h>

#include "exac-def.h"
#include "exac-ro.h"



T_BOD3D kvadr;            /* Rozmery kvadru, ktery chceme spocitat */
int velikost_prace;       /* kolik prace se bude workerovi pridelovat v % */
int zadana_prace = 0;     /* Zadany podil prace */
int druh_funkce;          /* druh funkce Ro */
double d;                 /* integracni krok pro vypocet */
int pracujicich_workeru = 0;    /* Kolik delniku pracuje */


int mytid;          /* identifikatro procesu */




void log_start() {
    FILE *fout;
    fout = fopen(LOG_FILE, "w");
    fclose(fout);
}





void pridel_praci(int tid)
{
    
    if (zadana_prace < 100) {
        printf("Hlavni %d: Prideluji praci delnikovi %d, prideleno %d\%\n", mytid, tid, zadana_prace);    
        
        if ( (zadana_prace + velikost_prace) < 100 ) {        
            
            double start_x = kvadr.x / (double) 100 * (double) zadana_prace;
            double start_y = 0.0;
            double start_z = 0.0;

            double konec_x = kvadr.x / (double) 100 * (double) (zadana_prace + velikost_prace);
            double konec_y = kvadr.y;
            double konec_z = kvadr.z;
            
            /* Zaslani prace workerovi */
            pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
            pvm_pkdouble(&start_x, 1, 1);
            pvm_pkdouble(&start_y, 1, 1);
            pvm_pkdouble(&start_z, 1, 1);
            pvm_pkdouble(&konec_x, 1, 1);
            pvm_pkdouble(&konec_y, 1, 1);
            pvm_pkdouble(&konec_z, 1, 1);
            pvm_pkdouble(&d, 1, 1);
            pvm_pkint(&druh_funkce, 1, 1);
            pvm_send(tid, MSG_PRACE);

            zadana_prace += velikost_prace;
        } else if ( (zadana_prace + velikost_prace) >= 100 ) {

            double start_x = kvadr.x / (double) 100 * (double) zadana_prace;
            double start_y = 0.0;
            double start_z = 0.0;

            double konec_x = kvadr.x;
            double konec_y = kvadr.y;
            double konec_z = kvadr.z;
            
            /* Zaslani prace workerovi */
            pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
            pvm_pkdouble(&start_x, 1, 1);
            pvm_pkdouble(&start_y, 1, 1);
            pvm_pkdouble(&start_z, 1, 1);
            pvm_pkdouble(&konec_x, 1, 1);
            pvm_pkdouble(&konec_y, 1, 1);
            pvm_pkdouble(&konec_z, 1, 1);
            pvm_pkdouble(&d, 1, 1);
            pvm_pkint(&druh_funkce, 1, 1);
            pvm_send(tid, MSG_PRACE);


            zadana_prace = 100;
        }
        pracujicich_workeru++;
    }
}




int main(int argc, char *argv[])
{

    log_start();

    /* Parametry vypoctu */
    int pocet_workeru;        /* Pocet workeru */
    double hmotnost = 0;      /* vysledna hmotnost - vystup */


    /* Prommenne programu */
    clock_t start_time, end_time;   /* Casove udaje pro zmereni doby behu programu */

    int tids[32];       /*  identifikatory procesu delnici */
    int* tidc;          /* pomocny ukazatel pro vytvareni delniku */
    int vytvoreno_workeru = 0;      /* pocet doposud vytvorenych workeru */
    int tid;            /* pomocny identifikator procesu */

    double dM;

    int i;
    
    if (argc == 8) {
        kvadr.x = atof(argv[1]);    
        kvadr.y = atof(argv[2]);    
        kvadr.z = atof(argv[3]);    
        d = atof(argv[4]);    
        sscanf(argv[5], "%d", &druh_funkce);    
        sscanf(argv[6], "%d", &pocet_workeru);    
        sscanf(argv[7], "%d", &velikost_prace);    
    } else {
			printf("\nIntegralni vypocet hmotnosti kvadru\n");
			printf("===================================\n\n");
			printf("Semestralni prace na PPR\n");
			printf("Miroslav Exner\tA02221\n");
			printf("exac@exac.info\twww.exac.info\n\n");
			printf("Musite zadat celkem 7 argumentu prikazove radky. Musite zadat\n\n");
			printf("exac-main.exe <x> <y> <z> <d> <c. funkce> <pocet vlaken> <velikost prace>\n");
			printf("   <x> <y> <z>      - rozmery kvadru\n");
			printf("   <d>              - integracni krok pro vsechny osy\n");
			printf("   <c. funkce>      - cislo funkce hustoty 1, 2, nebo 3\n");
			printf("                         1 - ro(x, y, z) = 1\n");
			printf("                         2 - ro(x, y, z) = x\n");
			printf("                         3 - ro(x, y, z) = x+y+z\n");
			printf("   <pocet vlaken>   - pocet vlaken, do kterych rozdelujeme ulohu\n");
			printf("   <velikost prace> - v % dil pridelovane prace vlaknu\n\n");
			printf("napr.:\n");
			printf("exac-main.exe 20 10 1 0.005 1 5 5\n\n");
			return ;
  
    }
	
    printf("\nIntegralni vypocet hmotnosti kvadru\n");
	printf("===================================\n\n");
	printf("Semestralni prace na PPR\n");
	printf("Miroslav Exner\tA02221\n");
	printf("exac@exac.info\twww.exac.info\n\n");    
    printf("---------------------------------------------------------------\n");
    printf("Rozmery kvadry <x, y, z>: %6.2f %6.2f %6.2f\n", kvadr.x, kvadr.y, kvadr.z);
    printf("Integracni krok: %6.8f\n", d);
    printf("Druh funkce: ");
    switch (druh_funkce) {
        case 1 :
            printf("ro(x, y, z) = 1\n");
            break;
        case 2 :
            printf("ro(x, y, z) = x\n");
            break;
        case 3 :
            printf("ro(x, y, z) = x + y + z\n");
            break;
        default :
            break;
    }    
    printf("Pocet delniku: %d\n", pocet_workeru);
    printf("Rozsah pridelovane prace: %d\%\n", velikost_prace);
    printf("---------------------------------------------------------------\n");
    

    start_time = clock();

    mytid = pvm_mytid();
    printf("Hlavni %d: Prihlasen do PVM\n", mytid);

    
    
    /* vytvoreni delniku */
    tidc = tids;
    while ( pocet_workeru > vytvoreno_workeru) {
        if (pvm_spawn("exac-worker.exe", (char**)0, 0, "", 1, tidc)) {
            printf("Hlavni %d: Vytvoren delnik %d.\n", mytid, *tidc);
            vytvoreno_workeru++;
            tidc++;
        } else {
            printf("Hlavni %d: Chyba pri vytvareni delnika. Cislo chyby %d\n", mytid, *tidc);
        }
    }

  
  
    /* Rekneme delnikum kdo je tu sef */  
    pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
    pvm_pkint(&mytid, 1, 1);    /* ulozeni identifikace */
    pvm_mcast(tids, pocet_workeru, MSG_REGISTRACE);  /* broadcast zpravy s kodem 4 */



    /* cekani na odezvu od delniku */
    for(i = 0; i < pocet_workeru; i++) { 
        pvm_recv(-1, MSG_PRIPRAVEN);        /* kod PRIPRAVEN od delniku*/
        pvm_upkint(&tid, 1, 1);             /* id delnika */  
        //pvm_upkint(&worker_cnt, 1, 1);      /* pocet zpracovanych kousku prace delnika */  
        printf("Hlavni %d: Delnik cislo %d k praci pripraven\n", mytid, tid);
    }    



    /* Prideleni prace vsem workerum na pocatku */   
    for (i = 0; i < pocet_workeru; i++) {
        pridel_praci(tids[i]);
    }
    
    
    
    printf("Hlavni %d: Spoustim smycku zprav\n", mytid);
    while (1) {

        if (pvm_nrecv(-1, MSG_VYSLEDEK) > 0) {
            
            /* Vyhodnoceni zaslaneho vysledku */
            pvm_upkint(&tid, 1, 1);
            pvm_upkdouble(&dM, 1, 1);
            printf("Hlavni %d: Parcialni hmotnost z delnika %d: %6.10f\n", mytid, tid, dM);
            hmotnost += dM;
            pracujicich_workeru--;
        
            /* Zadani nove praci - je-li */
            pridel_praci(tid);            
        }

        if ( (pracujicich_workeru <= 0) && (zadana_prace >= 100)) {
            break;
        }

    }
    printf("Hlavni %d: Ukoncuji smycku zprav\n", mytid);

  



    /* Ukonceni delniku */
    printf("Hlavni %d: Ukoncuji delniky. Cekam na odezvu...\n", mytid);
    pvm_mcast(tids, pocet_workeru, MSG_KONEC);  /* broadcast zpravy s kodem KONEC */
    /* cekani na odezvu od delniku */
    for(i = 0; i < pocet_workeru; i++) { 
        pvm_recv(-1, MSG_KONEC);        /* kod KONEC od delniku*/
        pvm_upkint(&tid, 1, 1);             /* id delnika */  
        //pvm_upkint(&worker_cnt, 1, 1);      /* pocet zpracovanych kousku prace delnika */  
        printf("Hlavni %d: Delnik cislo %d ukoncen\n", mytid, tid);
    } 


    end_time = clock();


    /* Ukonceni PVM */
    pvm_exit();
    printf("Hlavni %d: Koncim s behem\n", mytid);

    
    
    /* Vysledky */
    printf("--------------------------------------------\n");
    printf("Hmotnost kvadru: %6.10f\n", hmotnost);
//    printf("Doba behu: %6.5f clocks\n", (double) ( (double )(end_time - start_time) /  (double) CLOCKS_PER_SEC) );
    printf("--------------------------------------------\n");

    
    return 0;
}
