/* ========================================================================== */
/*                                                                            */
/*   Filename.c                                                               */
/*   (c) 2001 Author                                                          */
/*                                                                            */
/*   Description                                                              */
/*                                                                            */
/* ========================================================================== */


#include <stdio.h>
#include <pvm3.h>

#include "exac-ro.h"
#include "exac-def.h"




int mytid;      /* Identifikator delnika */
int chief_tid;  /*  identifikator procesu sef  */
BOOL ukoncit;   /* Ma delnik uz skoncit cinnost */



double vypocti(double start_x, double start_y, double start_z, double konec_x, double konec_y, double konec_z, double d, int druh_funkce)
{
    double x, y, z;
    double hmotnost, dm;
    int novy_prubeh, stary_prubeh;
    
    novy_prubeh = 0;
    stary_prubeh = 0;    
    hmotnost = 0;
    
    for (x = start_x; x < konec_x; x += d) {
        for (y = start_y; y < konec_y; y += d) {
            for (z = start_z; z < konec_z; z +=d) {
                dm = d * d * d * ro(x + d / (double) 2, y + d / (double) 2, z + d / (double) 2, druh_funkce );
                hmotnost += dm;

            }
        }
        novy_prubeh = (int) ( (x - start_x) / ((konec_x - start_x) / 100) );
        if (novy_prubeh != stary_prubeh) {
            printf("Delnik %d: Pocitam dilci hmotnost [%d\%]\n", mytid,  novy_prubeh);
            stary_prubeh = novy_prubeh;
        }    
    }

    return hmotnost;
}




void log(char *str)
{
    FILE *fout;
    fout = fopen(LOG_FILE, "a");
    fprintf(fout, "%s", str);
    fclose(fout);
}



int main(int argc, char *argv[])
{
    
    char pomstr[100];    
    //log_start();
    
    /* Prihlaseni do PVM */
    mytid = pvm_mytid();
    sprintf(pomstr, "Delnik %d: Vytvoren\n", mytid);
    log(pomstr);

    /* cekani na registraci od sefa */
    pvm_recv(-1, MSG_REGISTRACE);               /* REGISTRACE kod zpravy */
    pvm_upkint(&chief_tid, 1, 1);  /* zjisti cislo sefa */  



    /* kontrola zda je sef ten pravy - totozny s otcem */ 
    if (chief_tid == pvm_parent()) {

        /* odpoved sefovi */  
        pvm_initsend(PvmDataDefault);   /* inic. bufferu */
        pvm_pkint(&mytid, 1, 1);        /* ulozeni identifikace */
        //pvm_pkint(&cnt_work, 1, 1);     /* ulozeni citace */
        pvm_send(chief_tid, MSG_PRIPRAVEN);      /* kod odpovedi PRIPRAVEN */
    }

    
    ukoncit = FALSE;
    while (ukoncit == FALSE) {
    
    
        /* Pokud obdrzime zpravu s kodem PRACE */
        if (pvm_nrecv(chief_tid, MSG_PRACE) > 0) {
            
            double m;
            
            double start_x, start_y, start_z;
            double konec_x, konec_y, konec_z;
            double d;
            int druh_funkce;
            
            pvm_upkdouble(&start_x, 1, 1);
            pvm_upkdouble(&start_y, 1, 1);
            pvm_upkdouble(&start_z, 1, 1);
            pvm_upkdouble(&konec_x, 1, 1);
            pvm_upkdouble(&konec_y, 1, 1);
            pvm_upkdouble(&konec_z, 1, 1);
            pvm_upkdouble(&d, 1, 1);
            pvm_upkint(&druh_funkce, 1, 1);            
            
            
            m = vypocti(start_x, start_y, start_z, konec_x, konec_y, konec_z, d, druh_funkce);
    
            sprintf(pomstr, "Delnik %d: Dilci hmotnost: %6.10f\n", mytid, m);
            log(pomstr);
            
            /* Poslani vysledku */
            pvm_initsend(PvmDataDefault);  /* inic. bufferu */
            pvm_pkint(&mytid, 1, 1);
            pvm_pkdouble(&m, 1, 1);
            pvm_send(chief_tid, MSG_VYSLEDEK);        
        }
    
    
        /* Pokud obrdrzime zpravu s kodem ukoncit */
        if (pvm_nrecv(chief_tid, MSG_KONEC) > 0) {
            ukoncit = TRUE;
            sprintf(pomstr, "Delnik %d: Ukoncuji smycku\n", mytid);
            log(pomstr);
        }
    }
    

    /* Zaslani potvrzujici KONEC zpravy */
    pvm_pkint(&mytid, 1, 1);             /* ulozeni identifikace */
    pvm_send(chief_tid, MSG_KONEC);      /* kod odpovedi KONEC */
    
    
    
    /* ukonceni prace s PVM */
    pvm_exit();
    sprintf(pomstr, "Delnik %d: Koncim s behem\n", mytid);    
    log(pomstr);
    
    return 0;
}
