import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

public class Hlavni {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		int threads_number = 0; // implicitni pocet vytvorenych vlaken

		if (args.length < 3) {
			System.out
					.println("argumenty : pocet vlaken, velikost kusu prace pridelovaneho vlaknum, soubor");
			System.exit(0);
		}
		
		//pocdt vlaken
		threads_number = Integer.valueOf(args[0]).intValue();

		File soub = new File(args[2]); // zjisteni, zda soubor existuje
		if (!soub.isFile()) {
			System.out.println("Soubor neexistuje!");
			return;
		}

		Double[] vektor; //pole nactenych hodnot
		//nacitani hodnot ze souboru
		List<Double> pomList = new LinkedList<Double>();
		FileReader fr = new FileReader(soub);
		BufferedReader br = new BufferedReader(fr);
		String radka;
		while ((radka = br.readLine()) != null) {
			pomList.add(Double.valueOf(radka));
		}
		br.close();
		fr.close();
		
		vektor=new Double[pomList.size()];
		 pomList.toArray(vektor);//ziskani hodnot do pole z arraylistu

		int double_number = vektor.length; //pocet hodnot

		if (double_number < threads_number) {
			System.out.println("Pocet vlaken je vyssi nez pocet cisel!");
			return;
		}

		int double_per_thread = Integer.valueOf(args[1]).intValue(); //pocet zpracovavanych hodnot pro vlakno

		VypocteneHodnoty vh = new VypocteneHodnoty();

		Zpracovavani[] threadsfield = new Zpracovavani[threads_number];

		// vytvareni jednotlivych vlaken
		int od = 0;
		for (int i = 0; i < threads_number; i++) {
			threadsfield[i] = new Zpracovavani(double_per_thread, od, vektor,
					vh);
			threadsfield[i].start();
			od += double_per_thread;
			if ((od + double_per_thread) > double_number) {
				double_per_thread=(int) (double_number-od);
			}
		}

		// cekani na ukonceni vsech vlaken
		for (int i = 0; i < threads_number; i++) {
			try {
				threadsfield[i].join();
			} catch (InterruptedException e) {
				System.out.println("Thread is interrupted!");
			}
		}
		
		double avg = vh.getSum() / double_number;
		double roz = (vh.getSumX2() - (vh.getSum() * vh.getSum()))
				/ double_number;		
		double so = Math.sqrt(roz);

		System.out.println("Prumer je: " + avg);		
		System.out.println("Smerodatna odchylka je: " + so);
	}
}
