#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>
#include <math.h>
#define LINE	1000

int mpi_self; /* process number */
int mpi_npes; /* number of process */
int count; /* size of one part of work */
int items_number;
double *pole;

int read_file(char* filename){
  char str[LINE]; 	/* pomocny retezec na cteni ze souboru */
  FILE *soubor;
  int ch;
 //zjisteni, zda soubor existuje
  if ((soubor = fopen(filename, "r")) == NULL)  
  {
	   printf("Soubor neexistuje!\n");	
	   return 0;
  }
  
  items_number=0;
  //zjisteni poctu radku souboru
  while ( (ch = fgetc(soubor)) != EOF ){
        if ( ch == '\n' )
        {
          ++items_number; // Zvyseni poctu radku //
       }	    
  }
  fclose(soubor);           
  

  if ((pole = (double *)malloc(items_number * sizeof(double))) == NULL)
  {
     fprintf(stderr, "Nepodarilo se alokovat pamet!\n");       
     return 0;
  }   
    
  //nacitani hodnot ze souboru
  int i=0;
  soubor = fopen(filename, "r");
  while(fgets(str, LINE, soubor) != NULL){
     str[strlen(str)-1]='\0';    
	   pole[i]=atof(str);	   	   	   
	   i++;
  }
            
  fclose(soubor);
    
  //zpocitani kolik ma kdo zpracovat
  if (mpi_npes==1){
    count = items_number;
  }else{
    if ((items_number % mpi_npes) != 0) {  
      count = (items_number / mpi_npes)+1;
    }else{
      count = (items_number / mpi_npes);
    }
  }
  
  return 1;
} 

void pocitani(void){
  int i;
  double *prace;
  double sum=0;
  double qsum=0;
  double sumcelkem=0;
  double qsumcelkem=0;  
  /*posle kolik ma kdo zpracovat*/
  MPI_Bcast(&count, 1, MPI_INT, 0, MPI_COMM_WORLD);  
  double *work;
  work = (double*) malloc(count * sizeof(double));    
  
  /* posle cast ke zpracovani jednotlivym procesum */
  MPI_Scatter(pole, count, MPI_DOUBLE, work, 
              count, MPI_DOUBLE, 0, MPI_COMM_WORLD);
  
  
  
  /* spovitej sumy */
  for (i = 0; i < count; i++) {    
    sum+=work[i];
    qsum+=work[i]*work[i];    
  }  
  
  /* secti vsechny */
  MPI_Allreduce(&sum, &sumcelkem, 1, MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
  MPI_Allreduce(&qsum, &qsumcelkem, 1, MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);
  
  
  if (mpi_self == 0) {
    printf("prumer:%f\n",sumcelkem/items_number);
    double odchylka=(qsumcelkem-(sumcelkem*sumcelkem))/items_number;
    odchylka=sqrt(odchylka);
    printf("smerodatna odchylka:%f\n",odchylka);
  }
    
}

int main (int argc, char *argv[]) {
  int ok = 0;
  
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &mpi_self);
  MPI_Comm_size(MPI_COMM_WORLD, &mpi_npes);

  if (mpi_self == 0) {
    if (argc == 2) {
      ok = read_file(argv[1]);    
    }
    else {      
       printf("Argumenty : soubor\n");
    }
  }

  /* cekani na precteni souboru*/
  MPI_Bcast(&ok, 1, MPI_INT, 0, MPI_COMM_WORLD);

  if (ok) {
    pocitani();    
  }

  MPI_Finalize();
  return 0;
}
