/* PVM - ukazka vypocetniho modelu Farmer - Workers               */
/* Sef nacte soubor vstupnich hodnot ten preda delnikum ktery     */
/* spocitaji soucet a soucet druhych mocnin ve zvolenem intervalu */ 
/* Pouzivane kody zprav:                                          */
/*   4 ... broadcast (pocatecni udaje  -> delnici)                */  
/*   7 ... vysledek     (delnik -> sef),                          */
/* Pavel Tyll, A06596, tyll@centrum.cz                            */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <pvm3.h>

#define LINE	1000

  
main(int argc, char *argv[]) {
  FILE *soubor;		/* vstupni soubor */
  int mytid;      /*  identifikator procesu sef  */
  int nproc;      /*  pocet delniku */        
  int i;          /*  pomocne promenne */  
  int vytvoreno = 0;  /*  pocet uspesne vytvorenych delniku */
  int* tidc;      /* pomocny ukazatel pro vytvareni delniku */
  int item_per_worker;	/*pocet cisel na delnika */		  
  int pointer = 0;		/*ukazatel na pozici v souboru */
  double suma=0;		/* celkovy soucet */
  double qsuma=0;		/* celkovy soucet mocnin */
  double avg;    	/* celkovy prumer */
  double odchylka;  /* smerodatna odchylka */
  int items_number=0;		/* pocet cisel v souboru */
  double presult;		/* castecny souset od delnika */
  char str[LINE]; 	/* pomocny retezec na cteni ze souboru */  
  int *wtids;			/* pole id delniku */   
  int ch; /* pomocna promena pro cteni ze souboru */
  
  
  //zjisteni argumentu
  if (argc != 4)
  {
	   printf("Argumenty : pocet delniku, velikost kusu pridelovane prace, soubor\n");	   
	   exit(1);
  }

  //pocet cisel na delnika
  item_per_worker = atoi(argv[2]);

  //pocet procesu
  nproc= atoi(argv[1]);
  
  //alokace vektoru delniku
  if ((wtids = (int *)malloc(nproc * sizeof(int))) == NULL)
  {
     fprintf(stderr, "Nepodarilo se alokovat pamet!\n");       
     exit(1);
  }   
      
  //zjisteni, zda soubor existuje
  if ((soubor = fopen(argv[3], "r")) == NULL)  
  {
	   printf("Soubor neexistuje!\n");	
	   exit(1);
  }
  
  //zjisteni poctu radku souboru
  while ( (ch = fgetc(soubor)) != EOF ) 
  {
        if ( ch == '\n' )
        {
          ++items_number; // Zvyseni poctu radku //
       }	    
 }
  fclose(soubor);

  double *pole;
  if ((pole = (double *)malloc(items_number * sizeof(double))) == NULL)
  {
     fprintf(stderr, "Nepodarilo se alokovat pamet!\n");       
     exit(1);
  }   


    
  //nacitani hodnot ze souboru
  i=0;
  soubor = fopen(argv[3], "r");
  while(fgets(str, LINE, soubor) != NULL)
  {     
	   pole[i]=atof(str);	   	   	   
	   i++;
  }
            
  fclose(soubor);
        
    
  
  


  mytid = pvm_mytid();  /* prihlaseni do PVM */

  /* vytvoreni delniku */

  tidc=wtids;
  while (nproc>vytvoreno) {
   if (pvm_spawn("worker", (char **)0, 0, "", 1, tidc)) {            
      vytvoreno++;
      tidc++;      
   }
  }

  
  /* poslani udaju delnikum */
  for(i=0; i<nproc; i++) {
    pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
    pvm_pkint(&mytid, 1, 1);    /* ulozeni identifikace */
    pvm_pkint(&items_number, 1, 1);    /* pocet cisel */
    pvm_pkdouble(pole,items_number,1); /*pole cisel */
    pvm_pkint(&item_per_worker, 1, 1);    /* kolik jich zpracovat */
    pvm_pkint(&pointer, 1, 1);    /* odkud zpracovat */
    pvm_send(wtids[i], 4);     /* kod zpravy 4 */
    pointer += item_per_worker;
  }   
  
  
  /* prijmani vysledku */
  for (i=0; i<nproc; i++) 
	{	  
	  pvm_recv(-1, 7);  //byla-li prijata zprava   	  		
		pvm_upkdouble(&presult, 1, 1);
		suma += presult;
		pvm_upkdouble(&presult, 1, 1);
		qsuma += presult;						
	}

  avg=suma/items_number;	
  printf("prumer :%f\n",avg);
  odchylka=(qsuma-(suma*suma))/items_number;
  odchylka=sqrt(odchylka);
  printf("odchylka :%f\n",odchylka);

  /* ukonceni cinnosti v PVM */
  pvm_exit();
}
