/* PVM - ukazka vypocetniho modelu Farmer - Workers               */
/* Sef nacte soubor vstupnich hodnot ten preda delnikum ktery     */
/* spocitaji soucet a soucet druhych mocnin ve zvolenem intervalu */ 
/* Pouzivane kody zprav:                                          */
/*   4 ... broadcast (pocatecni udaje  -> delnici)                */  
/*   7 ... vysledek     (delnik -> sef),                          */
/* Pavel Tyll, A06596, tyll@centrum.cz                            */
#include "pvm3.h"
#include <stdio.h>
#include <stdlib.h>

#define LINE	1000

main(int argc,char *argv[]) {
  int mytid;      /*  identifikator procesu delnik     */
  int chief_tid;  /*  identifikator procesu sef        */        
  double suma=0;	/*  souctova promenna                */
  double qsuma=0;	/*  soucet mocnin                    */
  int from;		    /* od jakeho prvku pocitat           */
  int number;	    /* kolik prvku pocitat               */   
  int zaznamu;    /* pocet nactenych hodnot ze souboru */  
    
  mytid = pvm_mytid();  /* prihlaseni do PVM */

  /* cekani na zpravu od sefa */
  pvm_recv(-1, 4);               /* 4 je kod zpravy */
  pvm_upkint(&chief_tid, 1, 1);  /* zjisti cislo sefa */  
  pvm_upkint(&zaznamu, 1, 1);    /* zjisti pocet hodnot */
  double pole[zaznamu];
  pvm_upkdouble(pole,zaznamu,1);  
  pvm_upkint(&number, 1, 1);  /* zjisti prvku pocitat */
  pvm_upkint(&from, 1, 1);  /* zjisti od jakeho prvku */
  
  
  int i=0;
  for (i=from;i<(number+from);i++)
  {
    if(i>zaznamu) /* kdyz je i vetsi nez celkovy pocet prvku */
    {
      break;
    }
    suma += pole[i];
	  qsuma = qsuma + pole[i] * pole[i];
  }
  
  /* vytvoreni a poslani zpravy */
  pvm_initsend(PvmDataDefault);/* inic. bufferu */         
  pvm_pkdouble(&suma, 1,  1);      
  pvm_pkdouble(&qsuma, 1,  1);    
  pvm_send(chief_tid, 7);     /* kod odpovedi 7 */    

  /* ukonceni cinnosti */
  pvm_exit();
}
