/**
 * 
 * Tda dlnka, posl poadavky na prci monitoru, provd skalrn souin
 * dle pijatch index a vsledek vrac zpt do monitoru
 * 
 */
public class Worker extends Thread 
{
	private Matrix multiplicant;
	private Matrix multiplier;
	
	private Monitor monitor;
		
	public Worker(Matrix source, Monitor monitor) 
	{
		this.multiplier = source;
		this.multiplicant = source; 
		
		this.monitor = monitor;  
	}
	
	public void setMultiplicant(Matrix multiplicant)
	{
		this.multiplicant = multiplicant;
	}
	
	public void run() 
	{
		WorkPart wp = null;
		
		do
		{
			while((wp = monitor.getNextWorkPart()) != null)
			{
				long[] result = new long[wp.getWorkCount()];
				
				for (int k = 0; k < wp.getWorkCount(); k++)
				{
						
					int columnIndex = (wp.getColumnIndex() + k) % multiplicant.getDimension();
					int rowIndex = wp.getRowIndex() + (wp.getColumnIndex() + k) / multiplicant.getDimension(); 
										
					long[] column = multiplier.getColumn(columnIndex);
					long[] row = multiplicant.getRow(rowIndex);
										
					for (int i = 0; i < multiplicant.getDimension(); i++)
					{
						result[k] += column[i] * row[i];
					}
					
				}
				
				monitor.updateResult(result, wp);
			}
		}	
		while(monitor.getNextMultiplicant());
	}
	
}
