/* Semestralni prace z PPR - Nalezeni podretezce v retezci pomoci PVM
 *
 * Lukas Mastalir (lumas@students.zcu.cz)
 *
 * porgram worker - je pousten programem farmer
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <math.h>
#include <pvm3.h>
#include "hlp.h" //knihovna pomocnych funkci

// funkce, ktera vyhledava podretezce v retezci (v jeho casti)
// vysledne indexy vraci v poli integru,do promene finded vrati pocet
// nalezenych promenych
int *find_string(char *str_in,char* f_str,int position,int *finded) {
  int i,j;
  int nalezeno,poc;
  int *vystup;
  
  poc = 0;
  printf("pocet:%d",poc);
  if((vystup = (int *) malloc(1*sizeof(int))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  i = 0;    
  while (i <= (strlen(str_in)-strlen(f_str)) ) {
    nalezeno = 0;
    for (j = 0;j < strlen(f_str);j++) {
      if (str_in[i+j] == f_str[j]) {
        nalezeno = 1;
      }
      else {
        nalezeno = 0;
        break;
      }   
    }   
    if (nalezeno) {
      if((vystup = (int *) realloc(vystup,(poc+1)*sizeof(int)))== NULL) {
                   printf("Malo pameti!");
                   exit(1);
      }
      vystup[poc] = i+position;
      i += strlen(f_str) - 1;
           poc++;
    }
    else {
      i++;
    }   
  }/*while*/
  (*finded) = poc;
  return vystup;    
}   

int main(int argc, char *argv[]) {
  int chief_tid; // id farmera
  int mytid;     // id workera
  char *str_in;  // prohledavany retezec
  char *f_str;   // hledany retezec
  int *vystup;   // pole intu - nalezene indexy vyskytu podretezce
  int pocet;	 // pocet nalezenych vyskytu
  int i;	 // pomocna promena
  int odkud;	 // odkud se bude retezec prohledavat
  int kam;	 // az kam se bude v retezci prohledavat	
  FILE *fr;
  char *help_str; // pomocny string - vznikne oriznutim celeho retezce na cast
		  // ktera se bude skutecne prohledavat
 
  mytid=pvm_mytid();      // prihlaseni do pvm
  chief_tid=pvm_parent(); // zjisteni id farmare
  if (argc != 5) { printf("Chybne argumenty.\n"); pvm_exit(); exit(1); }      
  odkud=atoi(argv[2]);    // odkud se bude proheldavat
  kam=atoi(argv[3]);      // az kam se bude prohledavat
  f_str=argv[4];          // hledany retezec
  fr=fopen(argv[1],"r");  // otevrit soubor se vstupnimi daty
  str_in = read_file(fr); // nacteni retezce ve kterem se vyhledava
  close_f(fr);
  
  if((help_str = (char *) malloc((kam-odkud+2)*sizeof(char))) == NULL) {
    printf("Malo pameti!\n");
    exit(1);
  }
  // vytvoreni retezce ve kterem se skutecne prohledava
  for(i=0;i<(kam-odkud+1);i++){
    help_str[i] = str_in[odkud+i];
  }
  help_str[kam-odkud+1]='\0';
  
  vystup = find_string(help_str,f_str,odkud,&pocet);

  //inicializace vysilaciho bufferu
  if (pvm_initsend(PvmDataDefault) == 0) {
    fprintf(stderr,"Chyba pri inicializaci vysilaciho bufferu!\n");
    pvm_exit();
  }

  pvm_pkint(&pocet,1,1);  // odesle farmerovi kolik nasel podretezcu
  if(pocet != 0) {
   pvm_pkint(vystup,pocet,1); // posle pole vysledku
  }
  pvm_send(chief_tid, MSG_TAG); // MSG_TAG je 5

  free(vystup);free(help_str);free(str_in);  
  pvm_exit(); // odhlaseni z pvm  
      
  return(0);
}
