/* Zdenek Maxa (xmax@students.zcu.cz)
 * Semestralni prace z PPR - Numericka derivace vstupniho vektoru pomoci PVM
 * spustitelny soubor worker je spusten programem farmer prostrednictvim PVM
 * worker nacte data ze vstupniho souboru ktery je workerovi predan jako
 * vstupni argument, vysledna data jsou poslana farmerovi
 * worker.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <pvm3.h>
#include "general.h"

// nacitani vstupnich dat ze souboru, nacita se pole uhlu a sinu
void read_in_data(FILE *fr, double *ang, double *in, int number) {
int count;
   for(count=0; count<number; count++)
       fscanf(fr,"%lf %lf", &(ang[count]), &(in[count])); // uhel +  sinus
}

// funkce pocitajici vlastni derivaci, operuje s uplnymi poli vstupnich dat,
// vypocet ale fakticky provadi pouze nad jejich castmi danymi vstupnimi
// argumenty programu worker, funkce vraci ukazatel na pole s vysledky
// kontroluje zda nepracuje na mezich poli
double *make_deriv(double *ang, double *in, int from, int count, int num) {
   double res1, res2, h, *out;  // dilci vysledky a krok a pole pro vysledek
   int i; // pomocna
       out=aloc_double_field(count); // alokace pole pro vystupni hodnoty
       for (i=0; i<count; i++, from++) {
          if (from==0) {  h = fabs( ang[from+1] - ang[from] ); // prvni 
                          res1 = ( in[from+1] - in[from] ) / h;
                          out[i] = res1; 
                       }
          if (from+1==num) { h = fabs( ang[from] - ang[from-1] ); // posledni
                             res2 = ( in[from] - in[from-1] ) / h;
                             out[i] = res2;
                           }
          if ( (from != 0) && (from+1 != num) ) {  // ostatni prvku v poli
             h = fabs( ang[from+1] - ang[from] );
             res1 = ( in[from+1] - in[from] ) / h;
             h = fabs( ang[from] - ang[from-1] );
             res2 = ( in[from] - in[from-1] ) / h;
             out[i] = (res1 + res2) / 2;                             
          }   
       }
       return(out);
}   

int main(int argc, char *argv[]) {
   int chief_tid; // id farmera
   int mytid;     // id workera
   int from, count, num; // odkud se bude nacitat a kolik ; celk. pocet prvku
   double *ang, *in; // pole pro vstupni data nactena ze souboru
   double *deriv; // pole pro vysledek vypoctu - derivaci in[]
   FILE *fr;
// promenne pro ladeni
// char soub[100];   int i;   FILE *fw;
   
   mytid=pvm_mytid(); // prihlaseni do pvm
   chief_tid=pvm_parent(); // zjisteni id farmare
   if (argc != 5) { printf("Chybne argumenty.\n"); pvm_exit(); exit(1); }      
   fr=open_file(argv[1],"r"); // otevrit soubor se vstupnimi daty
   from=atol(argv[2]);    // odkud se bude pocitat
   count=atol(argv[3]);   // kolik se toho bude pocitat
   num=atol(argv[4]);     // kolik je celkem prvku ve vstupnim souboru
   ang=aloc_double_field(num); // pole pro vektor uhlu
   in=aloc_double_field(num);  // pole pro vektor vyhlazenych sinu
   read_in_data(fr,ang,in,num); // nacteni vstupnich dat do obou poli
   close_file(fr);

   deriv=make_deriv(ang, in, from, count, num); // vlastni vypocet derivace

   //inicializace vysilaciho bufferu
   if (pvm_initsend(PvmDataDefault) == 0) {
     fprintf(stderr,"Chyba pri inicializaci vysilaciho bufferu!\n");
     pvm_exit();
   }
   //vytvoreni a poslani zpravy
   pvm_pkint(&count,1,1);  // odesle farmerovi kolik toho skutecne pocital
   pvm_pkdouble(deriv,count,1); // a vektor derivace
   pvm_send(chief_tid, MSG_TAG); // 5 je kod zpravy
   
// pro ucely ladeni: kazdy worker vypise sve vstupy a vystupy do souboru
//   sprintf(soub, "%d", mytid);
//   fw=open_file(soub,"w");
//   for (i=0; i<count; i++) 
//      fprintf(fw,"worker: %d   uhel: %f  sin: %f    derivace: %f \n",
//                    mytid, ang[i+from], in[i+from], deriv[i]);   
//   fprintf(fw,"file: %s, from: %d, count: %d, num: %d\n",argv[1],
//          from,count,num);
//   close_file(fw);
   
   free(ang); free(in); free(deriv); // dealokace
   pvm_exit(); // odhlazeni z PVM
   return(0);
}

