package info.exac.ppr;

import java.util.ArrayList;
import java.util.GregorianCalendar;

public class ThreadManager extends Thread {

	/* Parametry ulohy */
	private int pocetVlaken;
	private int velikostPrace;
	private double d;
	private int jakaFunkce;
	private Bod3D kvadr = null;
	

	private ArrayList<HmotnostThread> vlakna = null;
	
	private double hmotnost = 0;
	
	private int pridelenaPrace = 0;
	
	private boolean hotovo = false;
	
	private long startTime = 0;
	private long endTime = 0;
	
	
	public ThreadManager(Bod3D kvadr, double d, int jakaFunkce, int pocetVlaken, int velikostPrace) {
		super();
		this.kvadr = kvadr;
		this.d = d;
		this.jakaFunkce = jakaFunkce;
		this.pocetVlaken = pocetVlaken;
		this.velikostPrace = velikostPrace;
		
		this.vlakna = new ArrayList<HmotnostThread>();
		
		vytvorVlakna();
		
	}

	
	
	private void vytvorVlakna() {
		for (int i = 0; i < pocetVlaken; i++) {
			vlakna.add(new HmotnostThread());
		}		
	}
	
	
	
	public void vypis() {
		
		/* Vypise stav vlaken */
		System.out.println("ThreadManager:\trozdeleno " + pridelenaPrace + "%");
		for (int i = 0; i < pocetVlaken; i++) {
			vlakna.get(i).vytiskni();
		}			
		System.out.println();		
	}
	
	
	
	private synchronized void pridelPraciVlaknu(int index) {
		
		HmotnostThread vlakno = vlakna.get(index);
		
		
		/* Je vubec co pridelovat ? */
		if (pridelenaPrace < 100) {
			
			
			if (pridelenaPrace + velikostPrace < 100) {
				vlakno.nastavVypocet((double)pridelenaPrace/100 *kvadr.x, 0, 0, (double)(pridelenaPrace+velikostPrace)/100 *kvadr.x, kvadr.y, kvadr.z, d, jakaFunkce);
				vlakno.vypocti();
				pridelenaPrace += velikostPrace;
			} else {
				vlakno.nastavVypocet( (double)pridelenaPrace /100 *kvadr.x, 0, 0, kvadr.x , kvadr.y, kvadr.z, d, jakaFunkce);
				vlakno.vypocti();
				pridelenaPrace = 100;				
			}			
			
			
		} else {
			vlakno.umri();
		}
	}
	
	
	public void run() {
		
		startTime = new GregorianCalendar().getTimeInMillis();
		
		/* Odstartuje vlakna */
		for (int i = 0; i < pocetVlaken; i++) {
			vlakna.get(i).start();
		}

		
		
		boolean ukoncitSmycku = false;
		while (!ukoncitSmycku) {
			
			ukoncitSmycku = true;
			for (int i = 0; i < pocetVlaken; i++) {
				
				HmotnostThread vlakno = vlakna.get(i);
				
				
				
				if (vlakno.getStav() == HmotnostThread.STAV_VYTVORENE) {
					pridelPraciVlaknu(i);
				}
				
				if (vlakno.getStav() == HmotnostThread.STAV_VYPOCTENE) {
					hmotnost += vlakna.get(i).getHmotnost();
					pridelPraciVlaknu(i);
				}
				
				
				if (vlakno.getStav() != HmotnostThread.STAV_UMIRAJICI) {
					ukoncitSmycku = false;
				}
			}

		}		
		
		endTime = new GregorianCalendar().getTimeInMillis(); 
		this.hotovo = true;
	}

	
	public boolean isHotovo() {
		return hotovo;
	}
	
	
	public double getHmotnost() {
		return hmotnost;
	}
	
	
	public long getCasVypoctu() {
		return ( (endTime - startTime) > 0) ? endTime - startTime : 0;
	}
	
}