/**
 * Trida ThreadCounter, pro kontrolu delniku
 * @author Pavel
 *
 */

public class ThreadCounter {
	private int counter = 0;
	private int threadNo = 0;
	private Object lock = new Object();
	
	public ThreadCounter(int threadNo) {
		this.threadNo = threadNo;         // nastavi cislo vlakna
	}
	
	/**
	 * pocka na ukonceni vsech vlaken
	 */
	public void waitForAll() {
		synchronized (lock) {               // nad zamkem
			while(this.counter < this.threadNo) {
				try {
					this.lock.wait();			// pozastavime vlakno
				} catch (InterruptedException e) {
					// nechci reagovat na vyjimku
				}
			}
		}
	}
	
	/**
	 * inkrementuje citac vlaken
	 */
	public synchronized void increment() {
		this.counter++;
		synchronized(this.lock){
			this.lock.notifyAll();		// probudime vsechna vlakna ktera byla pozastavena metodou wait
		}
	}

}
