#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <pvm3.h>
//#include "pvm3.h"
#include "messages.h"


char text[LINES][LINE_LENGTH];   // max radku o max znacich
int pozice[LINES][LINE_LENGTH + 1];  // nalezene pozice, pozice[radek][0] obsahuje vzdy pocet nalezenych pozic, je to kvuli absenci pole.length
int pocet_radku;


void unit_test(void) {
  int i;
  
  for (i = 0; i < pocet_radku; i++) {
    int j = 0;
    while (text[i][j] != 0) {
      printf("%c", text[i][j]);
      j++;
    }
    printf("\n");
  }
}


/* nacte textovy soubor a vrati pocet nactenych radku */
/* predpoklada alokovanou matici textu */
int nacti_soubor(char *soubor, int case_sensitive) {
  FILE *fr;
  int radku;  // pro cislovani radku
  int c;
  int x;
  
  if ((fr = fopen(soubor, "r")) == NULL) {
    printf("\nCHYBA: soubor '%s' se nepodarilo otevrit pro cteni !!!\n", soubor);
    exit(12);
  }

  radku = 0;
  x = 0;
  while ((c = getc(fr)) != EOF) {
    if (c == '\n') {
      text[radku][x] = '\0';   /* nutno ukoncit retezec nulovym znakem */
      radku++;
      x = 0;
    }
    else {
      if (!case_sensitive) {
        c = tolower(c);
      }
      text[radku][x] = (char) c;        // zapisu nacteny znak do datove struktury
      x++;
    }
  }
  
  if (x != 0) {             // pokud konci soubor radkem bez odradkovani
    text[radku][x] = '\0';   // ukoncim retezec
    radku++;
  }

  if (fclose(fr) == EOF) {
    printf("\nCHYBA: soubor '%s' se nepodarilo zavrit !!!\n", soubor);
    exit(13);
  }
  
  return radku;    // vracim pocet nactenych radku
}

/* prevede retezec na mala pismena */
void strtolower(char *str) {
  for ( ; *str != '\0'; str++) {    /* zvedam adresy a tim projizdim retezec */
    *str = tolower(*str);
  }
}

/*
 * posle praci delnikovi se zadanym tid. segment prace je sled radku od_radku do_radku
 * Posila se i cislo radku, aby pri prijmuti vedel farmar, kam ma dane pole vratit.
 */
void posli_praci(int od_radku, int do_radku, int tid, char *needle) {
  pvm_initsend(PvmDataDefault);
  int kolik_radku = do_radku - od_radku + 1;
  pvm_pkint(&kolik_radku, 1, 1);  // posleme info kolik radku posilame
  pvm_pkint(&od_radku, 1, 1);  // posleme index radku
  pvm_pkstr(needle);   // hledany retezec
  
  int i;
  for (i = 0; i < kolik_radku; i++) {  // posilam radky
    pvm_pkstr(text[od_radku + i]);   // posilany radek ke zpracovani
  }
  
  printf("Posilam radky %d - %d ke zpracovani delnikovi %d.\n", od_radku, do_radku, tid);
  pvm_send(tid, MSG_TODO);
}

/* farmer prideluje praci, dokud nedojde a vsichni delnici neskonci */
void makejte(int *tids, int ntask, int prace_radku, char *needle) {
  int pracujici;
  int tid, i;
  pracujici = 0;

  int udelano_segmentu = 0;
  int jednotka_prace = prace_radku;
  
  int segmentu = pocet_radku / jednotka_prace;          /* jednotlive kusy prace tj. skupina radku */
  if (pocet_radku % jednotka_prace != 0)
    segmentu++;
    
  if (ntask > segmentu) {
    printf("Error: zadanych procesu je vice nez vypoctenych segmentu prace!\nFlakali by se.\n");
    exit(23);
  }
  
  for (i = 0; i < ntask; i++) {
    
    // priprava segmentu prace
		int od_radku = udelano_segmentu * jednotka_prace;				// indexy v jedne praci zpracovavanych radku
		int do_radku = od_radku + jednotka_prace - 1;
		if (udelano_segmentu == segmentu - 1) {
			do_radku = od_radku + (pocet_radku - (segmentu - 1) * jednotka_prace) - 1;   // posledni nesoudelny segment prace, index do
		} 
    
    posli_praci(od_radku, do_radku, tids[i], needle);
    udelano_segmentu++;
    
    pracujici++;
  }
  
  while(1) {
    if (pvm_recv(-1, MSG_RESULT) > 0) {
      int kolik_radku;
      int od_radku;
      int pocet_nalezeno;

      pvm_upkint(&tid, 1, 1);
      pvm_upkint(&kolik_radku, 1, 1);         // kolik radku bylo zpracovano      
      pvm_upkint(&od_radku, 1, 1);         // index
      
      for (i = 0; i < kolik_radku; i++) {  // prijimam pole s pozicemi
        pvm_upkint(&pocet_nalezeno, 1, 1);         // kolik nalezeno pozic pro jeden radek
        pvm_upkint(pozice[od_radku + i], pocet_nalezeno + 1, 1);    // pocet je pocet nalezenych podretezcu na radku
        // + 1 protoze nulty index je delka pole
      }

      printf("Prijimam data od delnika %d.\n", tid);
   
      if (udelano_segmentu < segmentu) {         // jeste porad je prace
        // priprava segmentu prace
    		int od_radku = udelano_segmentu * jednotka_prace;				// indexy v jedne praci zpracovavanych radku
    		int do_radku = od_radku + jednotka_prace - 1;
    		if (udelano_segmentu == segmentu - 1) {
    			do_radku = od_radku + (pocet_radku - (segmentu - 1) * jednotka_prace) - 1;   // posledni nesoudelny segment prace, index do
    		} 

        posli_praci(od_radku, do_radku, tid, needle);     // delnika ktery nam odevzdal dil prace zase zamestname
        udelano_segmentu++;
      }
      else
        pracujici--;
      
      if (pracujici == 0)
        break;
    }
  }
}

/* vypsani napovedy */
void print_help(void) {
  printf("Semestralni prace z PPR - Pavel Gloss, A06082\n");
  printf("---------------------------------------------\n");
  printf("Spravne spusteni vypada takto:\n");
  printf("farmer.exe <pocet procesu> <prace> <vstupni soubor> <hledany retezec> <case sen>\n");
  printf("  <pocet procesu>    - pocet procesu delniku spustenych na vypocetnim clusteru\n");
  printf("  <prace>            - pocet radku textu kolik ma zpracovat jeden proces\n");
  printf("  <vstupni soubor>   - textovy soubor s radkami textu\n");
  printf("  <hledany retezec>  - retezec ktery hledame v textu\n");
  printf("  <case sen>         - rozlisovat velka a mala pismena a/n\n");
}

/* zkontrolujeme vstupni parametry programu */
void validace_parametru(int ntask, int prace_radku, char *case_sen, int *case_sensitive) {
  if (ntask < 1) {
    printf("\nError: <pocet procesu> musi byt alespon 1\n");
    exit(3);
  }
  if (prace_radku < 1) {
    printf("\nError: <velikost prace> musi byt alespon 1\n");
    exit(4);
  }
  if (tolower(case_sen[0]) == 'a') {
    *case_sensitive = 1;     // true
  }
  else if (tolower(case_sen[0]) == 'n') {
    *case_sensitive = 0;     // false
  }
  else {
    printf("\nError: <case sen> musi byt a/n\n");
    exit(5);
  }
}

// zobrazi tabulku pozic nalezeneho retezce
void vypis_vysledky(void) {
  printf("\nVypisuji nalezene pozice:\n");
  int i, r;
  for (r = 0; r < pocet_radku; r++) {
    int pozic = pozice[r][0];
    printf("radka[%d] --> ", r);
    for (i = 0; i < pozic; i++) {
      printf("%d, ", pozice[r][i + 1]);   // nulty index je pocet pozic
    }
    printf("\n");
  }
}

/* MAIN */
int main(int argc, char * argv[]) {
  char *soubor;      /* prohledavany textovy soubor */
  char *needle;      /* hledany podretezec */
  int mytid, i;
  int * tids;
  int prace_radku;    /* jednotka prace, tj. pocet radku textaku zpracovanych jednim delnikem */
  int case_sensitive;
  int ntask;            // pocet procesu delniku
  
  if (argc != 6) {
    printf("\nNespravny pocet parametru programu!\n");
    print_help();
    exit(2);
  }
  
  ntask = atoi(argv[1]);
  prace_radku = atoi(argv[2]);
  soubor = argv[3];
  needle = argv[4];
 
  validace_parametru(ntask, prace_radku, argv[5], &case_sensitive);    // vratim odkazem 0 nebo 1 case sensitive
  if (!case_sensitive) {
    strtolower(needle);  
  }
  
  tids = (int *) malloc(sizeof(int) * ntask);
  
  pocet_radku = nacti_soubor(soubor, case_sensitive);
  printf("Soubor nacten.\n");
  
  mytid = pvm_mytid();
  printf("Spoustim delniky...\n");
  
  clock_t start_time;
  clock_t stop_time;        /* casove udaje pro mereni casu vypoctu */
  double final_time;        /* celkovy cas trvani vypoctu */

  start_time = clock();   /* zacatek mereni casu vypoctu */
  
  // tady je prostor pro optimalizaci, predavat needle jako argument, tj. jen jednou kazdemu delnikovi
  i =	pvm_spawn("worker.exe", (char **) 0, PvmTaskDefault, (char *) 0, ntask, tids);

  if (ntask != i) {
    printf("Error : chyba pri spousteni delniku!\n");
    pvm_exit();
    exit(7);
  }
  
  for (i = 0; i < ntask; i++) {
    printf("Delnik %d je pripraven.\n" , i);
    pvm_recv(-1, MSG_READY);
  }
  
  makejte(tids, ntask, prace_radku, needle);  /* farmar zacne pridelovat praci */
  
  printf("Ukoncuji delniky.\n");  
  
  pvm_mcast(tids, ntask, MSG_QUIT);  //ukoncime delniky
  
  stop_time = clock();   /* konec mereni casu vypoctu */
  final_time = (double)(stop_time - start_time) / (double)CLOCKS_PER_SEC * 1000;
  
  vypis_vysledky();
  
  printf("\n\nCelkova doba vypoctu je %6.3f ms.\n", final_time);

  
  pvm_exit();   /* ukonceni farmare */
  free((void *) tids);
  
  return 0;
}
