/*
   Jmeno souboru : farmer.c
   verze         : 1.1
   kde, kdy, kdo : V Plzni, 1.2.2001 (d.m.r), Milos Siebert

   POPIS:
   Semestralni prace z predmetu Paralelni programovani KIV/PPR
   Program predelany z puvodniho FARMER.C od Stanislava Racka
*/


#include <stdio.h>
#include <pvm3.h>

/* PVM - ukazka vypocetniho modelu Farmer - Workers           */
/* Sef zadava delnikum postupne cela licha cisla do hodnoty m */
/*   a delnik zkouma, zda je to prvocislo. Vysledkem je  pole */
/*   vsech prvocisel az do hodnoty m.                         */
/* Pouzivane kody zprav:                                      */
/*   4 ... broadcast (id sefa  -> delnici)                    */
/*   5 ... odpoved   (id delnika -> sef)                      */
/*   6 ... zadani ukolu (sef -> delnik),                      */
/*         zaporna hodnota cisla znamena konec cinnosti       */
/*   7 ... vysledek     (delnik -> sef),                      */
/*         zaporna hodnota cisla znamena "neni to prvocislo"  */

main() {
  int mytid;      	/*  identifikator procesu sef  */
  int tids[32];   	/*  identifikatory procesu delnici */
  int nproc;      	/*  pocet delniku */

  int vytvoreno = 0;  	/*  pocet uspesne vytvorenych delniku */
  int end_param = 0;    /*  pomocna ridici poromenna */
  int i, tid;
  int* tidc;      	/* pomocny ukazatel pro vytvareni delniku */

  /* Pridane promenne*/
  int m;			/* Celkovy pocet bodu (VSTUP) */
  int m_step;			/* Pocet bodu pro jednoho delnika */
  int m_zbytek;			/* Kolik zbyva zadat bodu k vypoctu */
  int cislo_fce;		/* Cislo funkce z katalogu */
  double glob_suma = 0.0;	/* Globalni suma koeficientu */
  double parc_suma = 0.0;	/* Suma od jednoho delnika */
  double vysledek = 0.0;

  while (! end_param) {
    printf("Zadej pocet bodu: ");
    scanf("%d", &m);
    printf("Zadej pocet bodu na delnika: ");
    scanf("%d", &m_step);
    printf("Zadej cislo funkce: ");
    scanf("%d", &cislo_fce);
    printf("Zadej pocet delniku (1 az 32):");
    scanf("%d", &nproc);
    if ((m_step * nproc) > (m + m_step))
      printf("Prilis mnoho delniku - budou se flinkat!");
    else end_param = 1;
  }
  m_zbytek = m;		/* Zbyva spocitat m bodu -> vsechny */

  mytid = pvm_mytid();  /* prihlaseni do PVM */

  /* vytvoreni delniku */
  tidc = tids;

  while (nproc>vytvoreno) {
   if (pvm_spawn("worker", (char**)0, 0, "", 1, tidc)) {
      printf("Vytvoren delnik %d.\n", *tidc);
      vytvoreno++;
      tidc++;
   } else {
      printf("Chyba pri vytvareni delnika. Cislo chyby %d\n", *tidc);
   }
  }

  /* uvodni komunikace sefa s delniky (registrace prac. sil) */
  pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
  pvm_pkint(&mytid, 1, 1);    /* ulozeni identifikace */
  pvm_mcast(tids, nproc, 4);  /* broadcast zpravy s kodem 4 */
			      /*              vsem delnikum */
  /* cekani na odezvu od delniku */
  for(i=0; i<nproc; i++) {
    pvm_recv(-1, 5);         /* 5 je kod zpravy */
    pvm_upkint(&tid, 1, 1);  /* cislo delnika */
    printf("Delnik cislo %d k praci pripraven! \n ", tid);
  }

  /* pocatecni ukolovani delniku */
  for(i = 0; i < nproc; i++) {
    pvm_initsend(PvmDataDefault);	/* inicializace bufferu */
    pvm_pkint(&cislo_fce, 1, 1);	/* ulozeni hodnoty cislo_fce */

    if (m_zbytek < m_step) {            /* Test na zbytek bodu < m_step */
      pvm_pkint(&m_zbytek, 1, 1);       /* Ulozeni poctu bodu */
      m_zbytek = 0;
    }
    else {
      pvm_pkint(&m_step, 1, 1);		/* Ulozeni poctu bodu */
      m_zbytek -= m_step;
    }
    pvm_send(tids[i], 6);		/* zaslani zpravy s kodem 6 */
  }


  /* kdo dokoncil, dostane dalsi ukol */
  while (m_zbytek > 0) {
    pvm_recv (-1, 7);	 	/* cekani na vysledek */
    pvm_upkint (&tid, 1, 1);
    pvm_upkdouble (&parc_suma, 1, 1);	/* kopirovani do pole vysledku */

    glob_suma += parc_suma;		/* Pricteni parc. sumy k celk. */

    /* zadani dalsiho ukolu */
    pvm_initsend(PvmDataDefault);   /* inicializace bufferu */
    pvm_pkint(&cislo_fce, 1, 1);	/* ulozeni hodnoty cislo_fce */
    if (m_zbytek < m_step) {            /* Test na zbytek bodu < m_step */
      pvm_pkint(&m_zbytek, 1, 1);       /* Ulozeni poctu bodu */
      m_zbytek = 0;
    }
    else {
      pvm_pkint(&m_step, 1, 1);	      /* Ulozeni poctu bodu */
      m_zbytek -= m_step;
    }
    pvm_send(tid, 6);                 /* zaslani zpravy s kodem 6 */
  }


  /* dobeh rozdelanych ukolu */
  for(i = 0; i < nproc; i++) {
    pvm_recv (-1, 7);                 /* cekani na vysledek */
    pvm_upkint (&tid, 1, 1);
    pvm_upkdouble (&parc_suma, 1, 1); /* kopirovani do pole vysledku */

    glob_suma += parc_suma;	      /* Pricteni parc. sumy k celk. */


    m_step = -1;            /* Zaporna hodnota -> skonci praci workere */
    pvm_initsend(PvmDataDefault);     /* inicializace bufferu */
    pvm_pkint(&cislo_fce, 1, 1);      /* ulozeni hodnoty cislo_fce */
    pvm_pkint(&m_step, 1, 1);	      /* Ulozeni poctu bodu */
    pvm_send(tid, 6);                 /* zaslani zpravy s kodem 6 */
    printf("Delnik cislo %d praci ukoncil! \n ", tid);
  }


  /* Vypocet prumeru */
  vysledek = glob_suma / m;


  /* tisk vysledku */
  printf("Vysledek = %f \n", vysledek);

  /* ukonceni cinnosti v PVM */
  pvm_exit();

}
