/* Semestralni prace z PPR (zadani c.9 - vypocet vektoru derivaci)
 * Zdenek Maxa  xmax@students.zcu.cz
 *
 * Vstupni argument : pocet vlaken. Pokud je zadano vetsi cislo nez je pocet
 * vzorku, je pocet vlaken upraven na max. mozny pocet (= pocet vzorku)
 * deriv.java
 */ 
 
import java.lang.*;
import java.io.*;

class in_data { // trida s daty, nacita data ze souboru
  private static double[] in; // atribut tridy -> ulozeni vstupniho vektoru
  private static double[] in_angle; // uhel jednotliveho vzorku sinu
    
  public static int read_file(String name) throws IOException {
     RandomAccessFile fr=null;
     int num_double;

     try { fr=new RandomAccessFile(name,"r"); }
     catch (IOException e) {
       e.printStackTrace();
       System.out.println("Chyba pri otevirani souboru.");                           }
     
     num_double=fr.readInt(); // prvni cislo v souboru je pocet prvku vektoru
     in=new double[num_double]; in_angle=new double[num_double]; 
     // vlastni nacteni vstupnich dat
     for (int i=0; i<num_double; i++) {
          in_angle[i]= fr.readDouble(); // uhel prislusejici dane hodnote sinu
          in[i]      = fr.readDouble(); // sinus daneho uhlu se sumem
     }     
     fr.close();
     return num_double;     
  }
  // pristup k nactenym datum
  public static double[] get_in_angle_data()    {  return in_angle;  }
  public static double[] get_in_data()          {  return in;        }
}  

class outcome_reno { // trida pro praci s vyhlazenym vektorem sinu
   static double[] out_reno;  // pole pro vystup z "vyhlazeni" sumu
   outcome_reno(int number) {   
      out_reno=new double[number];
      for(int i=0; i<number; i++)  out_reno[i]=0;
    }   
   // vkladani prvku do pole
   static void insert(double in_number,int index) {out_reno[index]=in_number;} 
   // pristup k poli vyhlazenych sinu
   public static double[] get_outcome_reno() {return out_reno; }
}   

class outcome_deriv {   // trida pro ukladani vystupnich dat z derivovani
   static double[] out_deriv;  // pole pro vystup z derivovani
   outcome_deriv(int number) { 
      out_deriv=new double[number];
      for(int i=0; i<number; i++)  out_deriv[i]=0;
    }   
   // vkladani prvku do pole
   static void insert(double in_number,int index) {out_deriv[index]=in_number;}
   // pristup k poli obsahujici derivace vyhlazeneho vektoru
   public static double[] get_outcome_deriv() {return out_deriv; }
}   

// trida ktera definuje vlakna, ktera vyhlazuji vektor vstupnich dat
class part_reno extends Thread { // Particular Remove Noise
      int num;      // pocet prvku v poli se kterymi bude vlakno pracovat
      static double[] in;  
      // vstupni data -> bud cele vst.pole nebo cast pro 1 vlakno
      int index;    // index prvniho prvku k prumerovani
      outcome_reno out; // objekt pro ukladani vysledku
      double aver; // dilci vysledek 1 prvku
      
      // konstruktor vlakna, nastavi parametry kazdeho jednotliveho vlakna
      part_reno(double[] input,int from,int count,outcome_reno result) {
         in=input;    // pole se vstupnimi daty
         out=result;  // objekt pro ukladani vysledku do objektu outcome_reno
         num=count;   // pocet prvku pro jednotlivy Thread
         index=from;  // index v poli prvniho prvku k zpracovani
      }         
      // metoda run -> efektivni kod vlakna, vsechna vlakna bezi podle kodu run
      // cinnost metody run je jasne (viz teoreticky rozbor ulohy)
      // je vsak kontrolovat zda vlakno pracuje s 0. nebo poslednim prvkem
      public void run() {
         int help=in.length;
         for (int i=0; i<num; i++, index++) {
            if (index==0) out.insert(in[index],index);  // 0.prvek v poli ?
            if (index+1==help) { out.insert(in[index],index); break; }
            if (index+2==help) { out.insert(in[index+1],index+1); break; }
            aver=(in[index]+in[index+2]) / 2; // odstraneni sumu 
            out.insert(aver,index+1);    // ulozeni do vyhlazeneho vektoru  
          }
       }  
}

// trida definujici vlakna jez provadi derivaci
class part_deriv extends Thread { // Particular Derivace
      int num;      // pocet prvku v poli se kterymi bude vlakno pracovat
      static double[] in;  // vstupni data -> cele vst.pole (vlakno zpracovava cast)
      int index;    // index prvniho prvku k prumerovani
      outcome_deriv out; // objekt pro ukladani vysledku
      double h; // krok mezi vstupnimi promennymi fce sin()
      double res1,res2; // dilci vysledky derivace (viz vzorce pro derivovani)
      static double[] ang; // pole vstupu fce sin() -> urceni kroku h
      
      // konnstruktor kazdeho vlakna pro pocitani derivace 
      part_deriv(double[] angle,double[] input,int from,int count,outcome_deriv result) {
         in=input;    // pole se vstupnimi daty
         out=result;  // objekt pro ukladani vysledku do objektu outcome_deriv
         num=count;   // pocet prvku pro jednotlivy Thread
         index=from;  // index v poli prvniho prvku k zpracovani
         ang=angle;
      }         
      // jednotny kod kazdeho vlakna -> realizuje vlastne 2 vzorce pro vypocet
      // derivace, singularnimi pripady jsou hranice poli
      public void run() {
        int help=in.length-1; // pomocna
        for (int i=0; i<num; i++,index++) {          
          if (index==0) { h=Math.abs( ang[index+1] - ang[index] );
                          res1 = (in[index+1]-in[index]) / h;
                          out.insert(res1,index); // prvni hodnota v poli
                        }
          if (index==help) { h=Math.abs( ang[index] - ang[index-1] );
                              res2 = (in[index]-in[index-1]) / h;
                              out.insert(res2,index);//posledni hodnota v poli
                            }  
          if ( (index != 0) && (index != help) ) {
               h=Math.abs( ang[index+1] - ang[index] );
               res1 = ( in[index+1] - in[index] ) / h; // prvni vzorec
               h=Math.abs( ang[index] - ang[index-1] );
               res2 = ( in[index] - in[index-1]) / h; // druhy vzorec
               out.insert((res1+res2)/2,index); // ulozeni vysledku
          }          
        }            
      }
}

// hlavni trida ridici vyhlazeni vstupniho vektoru a jeho numerickou derivaci
// zaklada vlakna a sbira od nich data
public class deriv {   
  private static final String FILE_NAME="data/vect"; 
  static outcome_reno  res_reno; // objekt pro vysledek vyhlazovani vektoru
  static outcome_deriv res_deriv; // objekt pro vysledek derivovani

  public static void main(String argv[]) {  // pocet vlaken parametr
     int num=0;   
     int pointer=0; // ukazovatko odkud
     int num_thread=0; // pocet vlaken v kterych vypocet pobezi
     PrintWriter fw_reno =null; // soubor pro vystup dat po vyhlazeni
     PrintWriter fw_deriv=null; // soubor pro vystup dat po derivaci
     
     if (argv.length !=1) { // kontrola vstupnich parametru
        System.out.println("Nutny 1 celociselny arg - pocet vlaken (max."+
                           " velky jako pocet vzorku)");
        return;
     }   
     
     try { 
        num_thread=Integer.valueOf(argv[0]).intValue(); // je vstup. arg int
        num=in_data.read_file(FILE_NAME+".bin"); // vrati pocet prvku v souboru
        FileWriter fwReno = new FileWriter(FILE_NAME+"-reno.dat");
        fw_reno = new PrintWriter(fwReno);
        FileWriter fwDeriv = new FileWriter(FILE_NAME+"-deriv.dat");
        fw_deriv = new PrintWriter(fwDeriv);
        
     }
     catch (NumberFormatException e) {
        System.out.println("Chybny format vstupniho argumentu!");
        return;
     }   
     catch  (IOException e) {
       e.printStackTrace();
       System.out.println("Chyba pri otevirani souboru.");                           }       
     if (num_thread > num) { // je-li vstupni param.poctu vetsi nez pocet prvku
        System.out.println("Upravuji pocet vlaken na "+num);
        num_thread=num; // vlaken bude tolik jako vstupnich prvku
     }    
     if (num_thread < 1) { System.out.println("Pocet vlaken < 1!"); return; }
                
     double[] input=new double[num]; // alokace pole pro vstupni data
     input=in_data.get_in_data();  // pole se vstupnimi daty
     res_reno=new outcome_reno(num); // objekt pro vystupni data z vyhlazovani
     res_deriv=new outcome_deriv(num); // objekt pro vystup z derivovani

     int num_per_thread = num / num_thread; // pocet cisel pro 1 vlakno
     int rest_num = num % num_thread; // pocet vlaken co budou pocitat o 1 vic
     if (rest_num>0) ++num_per_thread;

     part_reno[] t_reno=new part_reno[num_thread]; // pole vlaken pro vyhlazeni
     pointer=0; // vytvoreni vlaken
     for(int i=0; i<num_thread; i++) {  // params odkud a kolik pro vlakna
        t_reno[i]=new part_reno(input,pointer,num_per_thread,res_reno);
        t_reno[i].start();
        pointer+=num_per_thread; // prenastaveni ukazovatka
        if (rest_num>=0) rest_num--; // sniz pocet vlaken pocitajicich o 1 vic
        if (rest_num==0) num_per_thread--;
     }   
     
     for(int i=0; i<num_thread; i++) { // cekani na vlakna
       try { t_reno[i].join(); }
       catch(InterruptedException e) {System.out.println("Vlakno preruseno");} 
     }   

     // derivace
     double[] in_deriv=new double[num];
     in_deriv=outcome_reno.get_outcome_reno();  // vstup do derivace
                                                // (vyhlazeny vektor)     
     double[] angle=new double[num];
     angle=in_data.get_in_angle_data(); // vektor uhlu

     // vytvoreni vlaken, rizeni jejich poctu vzhledem k poctu prvku ->
     // naprosto obdobne jako u vlaken pro vyhlazeni vektoru
     num_per_thread = num / num_thread; // pocet cisel pro 1 vlakno
     rest_num = num % num_thread; // pocet vlaken co budou pocitat o 1 vic
     if (rest_num>0) ++num_per_thread;
     
     part_deriv[] t_deriv=new part_deriv[num_thread]; // pole vlaken
     pointer=0;
     for(int i=0; i<num_thread; i++) {  // params odkud a kolik pro vlakna
        t_deriv[i]=new part_deriv(angle,in_deriv,pointer,num_per_thread,res_deriv);
        t_deriv[i].start();
        pointer+=num_per_thread;
        if (rest_num>=0) rest_num--;
        if (rest_num==0) num_per_thread--;
     }   

     for(int i=0; i<num_thread; i++) { // cekani na vlakna
       try { t_deriv[i].join(); }
       catch(InterruptedException e) {System.out.println("Vlakno preruseno");} 
     }   

     for (int i=0; i<num; i++) {  // vystup dat od vlaken na obrazovku
      System.out.println(i+".vz: uhel="+angle[i]+"  vstup: "+input[i]+
      "  vyhlaz.: "+res_reno.out_reno[i]+
      " derivace: "+res_deriv.out_deriv[i]);

       fw_reno.println(angle[i]+"  "+res_reno.out_reno[i]); //vystup do souboru
       fw_deriv.println(angle[i]+"  "+res_deriv.out_deriv[i]);
     } // v souborech : vyhlazeny a zderivovany vektor
     System.out.println("Pocet vzorku: "+num+".     Pocet vlaken: "+num_thread);
     
     fw_reno.close(); fw_deriv.close();
  }   
}

