/* Semestralni prace z PPR (zadani c.9 - vypocet vektoru derivaci)
 * Zdenek Maxa   email: xmax@students.zcu.cz
 *
 * Generator vzorku funkce sin(), generator sumu - snizeni urovne sumu 
 * nastaveni konstanty NOISE_DECREASE. Pocet vzorku za periodu 2PI je urcen
 * vstupnim parametrem.
 * Vystup se uklada do textoveho souboru (dalsi vystupy jsou bin. soubor a 
 * textove souboru pro generovani grafu programem gnuplot
 */

import java.lang.*;
import java.util.*;
import java.io.*;
import java.text.*;

public class genvec {
    
  private static final String FILE_NAME="data/vect";  // soubory pro vystup dat
  private static final double LEAST_SIN=1E-10;
  private static final int NOISE_DECREASE=10; // snizeni hladiny sumu 

  public static void main(String argv[]) throws IOException {
    double sin, noi, out, ang, inc; // sinus noise output angle increase
    Random ran=new Random(1); // random pro generovani sumu
    PrintWriter fw_txt=null,fw_sin=null,fw_noi=null; // jeden vyst. +2 pro graf
    int number=2; // i v pripade vyjimky se provedou 2 vzorky
    
    DataOutputStream fw_bin=null; // bin.soubor s "zasumenym" vektorem
    DecimalFormat f = new DecimalFormat("####0.0000"); // my format
    String out_Str = new String("");
    f.setMinimumIntegerDigits(1);  // pocet cislic pred. des.carkou

    if (argv.length !=1) { 
     System.out.println("Nutny 1 celociselny arg max.velikosti 360"+ 
                         " (pocet vzorku za periodu)");
     return;
    }       
    try { 
      number=Integer.valueOf(argv[0]).intValue(); 

      FileWriter fwForm = new FileWriter(FILE_NAME+".txt");
      fw_txt = new PrintWriter(fwForm);
      FileWriter fwSin = new FileWriter(FILE_NAME+"-sin.dat");
      fw_sin = new PrintWriter(fwSin);
      FileWriter fwNoi = new FileWriter(FILE_NAME+"-noi.dat");
      fw_noi = new PrintWriter(fwNoi);
      
      FileOutputStream fwBin = new FileOutputStream(FILE_NAME+".bin");
      fw_bin = new DataOutputStream(fwBin);
    }    
    catch (NumberFormatException e) {
       System.out.println("Chybny format vstupniho argumentu!");
       return;      
    }
    catch (IOException e) {
       e.printStackTrace();
       System.out.println("Chyba pri otevirani souboru.");
       return;
    }   

    fw_bin.writeInt(number);
    inc=(2*Math.PI)/(number);
    int i=1; // pouze pocitadlo vzorku, pomocna pro gen.sumu
    
    for(ang=0;  ang<(2*Math.PI); ang+=inc, i++) {  // vlastni vzorkovani
      sin=Math.sin(ang);
      noi=ran.nextDouble() / NOISE_DECREASE;  
      if (Math.abs(sin)<LEAST_SIN) sin=0;
      out=sin+noi;
      out_Str=f.format(out)+" vysl.    sum: "+f.format(noi)+"  sin:  "+
              f.format(sin)+"   uhel: "+f.format(ang);
      fw_sin.println(ang+"    "+sin); // soubor pro gen.grafu sin
      fw_noi.println(ang+"    "+out); // soubor pro gen. grafu "zasumeneho" sin
      fw_bin.writeDouble(ang);      fw_bin.writeDouble(out);
      fw_txt.println(out_Str);
      System.out.println("Vzorek c. "+i+"  "+out_Str);      
    }

    fw_txt.close();    fw_bin.close();    fw_sin.close();  fw_noi.close();
    System.out.println("\nVektor vzorku zapsan do "+
       "souboru \""+FILE_NAME+".txt\", pocet vzorku : "+number+"\n");
    }
}
