/* Zdenek Maxa (xmax@students.zcu.cz)
 * Semestralni prace z PPR - Numericka derivace vstupniho vektoru pomoci PVM
 * hlavni program, ktery spusti programy worker na strojich uvedenych v
 * hostfile. sbira finalni data od workeru a tiskne je (stdout, soubor)
 * spousti se : farmer <pocet workeru>
 * vstupni soubor je dan symbolickou konstantou : "vect-reno.dat", coz je
 * vyhlazeny vektor vzorku funkce sin, vystup: "vect-deriv-pvm.dat"
 * farmer.c 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pvm3.h>
#include "general.h"
#define FILE_NAME "vect-reno.dat" // jmeno vst.souboru (produkt deriv.java)
#define FILE_OUT "vect-deriv-pvm.dat" // soubor pro vystup
#define LENGTH_WOR_ARG 20 // delka pole pro argumenty pro 1 delnika
#define WORKER_NAME "worker" // jmeno spustitelneho souboru ( delnik )

int get_num_of_doubles(FILE *fr) { // vrati pocet prvku ve vstupnim souboru
int count=0; double ang,sin;   
   while ((fscanf(fr,"%lf %lf",&ang, &sin)) != EOF) count++;
   return(count);  // v souboru na radce uhel  +  vyhlazeny  sinus
}
/*############################################################################*/

int main(int argc, char *argv[]) {
   FILE *fr,*fw;
   int num=0; // celkovy pocet prvku v poli
   int mytid, *wtids, pointer=0; // id farmare a pole tid workeru, ukaz do pole
   double *deriv, *dh; // deriv help pointer
   int num_per_worker, rest_of_num, i; // cisel na delnika, zbytek nepridelenych
   char *w_arg[5]; // pole argumentu pro workery
   int num_worker=1; // pocet delniku
   
   fr=open_file(FILE_NAME,"r");
   num=get_num_of_doubles(fr); // zjisteni poctu prvku v souboru 
   close_file(fr);
   
   if (argc !=2) { print_help(); exit(1); }  // kontrola vstupnich argumentu
   num_worker=atoi(argv[1]);
   if (num_worker>num) { 
      printf("Prilis mnoho delniku. Upravuji na %d.\n",num);
      num_worker=num;
   }   

   deriv=aloc_double_field(num); // alokace pole pro vystupni vektor derivaci
   wtids=aloc_int_field(num_worker);  // pole pro identifikaci workeru
   
   num_per_worker=num / num_worker; // pocet prvku na delnika
   rest_of_num=num % num_worker; // zbytek: pocet delniku co pocitaji o 1 navic
   if (rest_of_num > 0) num_per_worker++;

   // alokace pameti pro argumenty workeru
   w_arg[0]=aloc_char_field(LENGTH_WOR_ARG);
   w_arg[1]=aloc_char_field(LENGTH_WOR_ARG);
   w_arg[2]=aloc_char_field(LENGTH_WOR_ARG);
   w_arg[3]=aloc_char_field(LENGTH_WOR_ARG);
   w_arg[4]=0x00; // ukonceni pole argumentu pro workera

   mytid=pvm_mytid(); // prihlaseni farmera do PVM (az po alokacich)

   strcpy(w_arg[0],FILE_NAME); // 1. arg pro delnika (jmeno souboru)
   for (i=0; i<num_worker; i++) {
      sprintf(w_arg[1], "%d", pointer); // 2. arg. (odkud bude pocitat)
      sprintf(w_arg[2], "%d", num_per_worker); // 3. arg. (kolik bude ...)
      sprintf(w_arg[3], "%d", num); // 4.arg - celkovy pocet prvku
      if (pvm_spawn(WORKER_NAME, w_arg, 0, "", 1, &(wtids[i])) != 1) {
         fprintf(stderr,"pvm_spawn: Task nebyl vytvoren!\n");
         pvm_exit();   exit(1);
      }
// ladeni : farmer vypise mytid vytvareneho pvm-procesu a jeho vstup. parametry
//    printf("Spusten %d, arg: %s, %s, %s, %s\n",wtids[i],w_arg[0],
//              w_arg[1],w_arg[2],w_arg[3]);
      pointer += num_per_worker;
      if (rest_of_num >= 0) rest_of_num--;
      if (rest_of_num == 0) num_per_worker--;
   }   
   
   // nacteni dat od delniku
   num_per_worker=0;
   dh=deriv; // pomocny pointer na vystupni vektor derivaci
   for (i=0; i<num_worker; i++) {
      pvm_recv(wtids[i],MSG_TAG); // blokujici -> ceka na prijem zpravy 
      dh=dh+num_per_worker; // posun pointeru od posledniho ukladani
      pvm_upkint(&num_per_worker, 1, 1); // kolik worker pocital ?
      pvm_upkdouble(dh,num_per_worker,1); // tolik toho od nej nacti
   }   
   
   fw=open_file(FILE_OUT,"w");
   for(i=0; i<num; i++) {
     printf("Derivace : %f\n", deriv[i]);  // tisk vystupu na stdout
     fprintf(fw,"Derivace : %f\n", deriv[i]); // a do souboru
   }  
   close_file(fw);
   
   free(deriv);   free(wtids); // dealokace
   free(w_arg[0]); free(w_arg[1]); free(w_arg[2]);  free(w_arg[3]);
   pvm_exit(); // odhlaseni z PVM
   return(0);
}  

