package bin;
public class WorkerMinMax extends Thread {
	private Farmer f; // reference to farmer
	private int min,max; // min&max (local data) - will be computed
	
	public WorkerMinMax(Farmer f) {
		this.f = f;
	}
	
	public void setMinMax(int min, int max) {
		this.min = min;
		this.max = max;
	}
	
	/* find local min, max */
	public void run() {
		Part p;
		
		 while (f.wait_for_work()) { // blocking
			 ;
		        do  {
		          // worker requests a piece of work
		          p = f.get_work();
		          if (p.empty() == false) {
		            for (int i = p.start; i < p.end; i++) {
		            	if(p.data[i] < min)
		            		min = p.data[i];
		            	else if(p.data[i] > max)
		            		max = p.data[i];
		            }
		            yield();
		          }
		        } while (p.empty() == false);
		        // update global result
		        f.setMinMax(min,max);
		      }
	}
}