package ppr;

import ppr.gui.MainFrame;
import ppr.threads.app.ArgumentsException;
import ppr.threads.app.Parameters;
import ppr.threads.app.PrintHelp;
import ppr.threads.app.ReadAppArguments;

/**
 * Uvodni trida aplikace. Podle poctu argumentu bud vypise chybu,  
 *
 */
public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("Vpoet hmotnosti kvdru");
		System.out.println("------------------------");
		System.out.println("Semestrln prce z pedmtu KIV/PPR");
		System.out.println();
		System.out.println("\tAutor:     Vt Lachner");
		System.out.println("\tSt. slo: A06093");
		System.out.println("\tE-mail:    lachner@students.zcu.cz");
		System.out.println();
		System.out.println();
		
		if (args.length == 7) {
			ReadAppArguments appArguments = null;
			
			try {
				appArguments = new ReadAppArguments(args);  // nacteni argumentu programu				
				final Parameters parameters = appArguments.getParameters();
								
				// vytvoreni vlakna pro GUI
				javax.swing.SwingUtilities.invokeLater(new Runnable() {
		            public void run() {
	            		new MainFrame(parameters);	// vytvoreni instance hlavniho okna aplikace	           
		            }
		        });
			} catch (ArgumentsException e) {  // chyba ve zpracovani argumentu
				e.printStackTrace();
			}			
			catch (Exception e) {  // jina chyba
				e.printStackTrace();
			}
		}
		else if ((args.length == 1) && (args[0].compareTo("-h") == 0))  // prvni argument je roven retezci '-h'
			new PrintHelp().print();   // tisk napovedy		
		else {
			//	vytvoreni vlakna pro GUI
			javax.swing.SwingUtilities.invokeLater(new Runnable() {
	            public void run() {
            		new MainFrame();   // vytvoreni instance hlavniho okna aplikace
	            }
	        });
		}
	}
}