package ppr.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import ppr.threads.app.ArgumentsException;
import ppr.threads.app.Parameters;
import ppr.threads.app.ro.FncConstant;
import ppr.threads.app.ro.FncX;
import ppr.threads.app.ro.FncXYZ;
import ppr.threads.app.ro.Fncs;
import ppr.threads.inteface.Reader;

/**
 * Hlavni okno aplikace. 
 *
 */
public class MainFrame extends JFrame implements Reader {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;
	
	private JLabel jlCountThreads = null;

	private JLabel jlPart = null;

	private JLabel jlX = null;

	private JLabel jlY = null;

	private JLabel jlZ = null;

	private JLabel jlD = null;

	private JLabel jlFncRo = null;

	private JButton jbStart = null;

	private JTextField jtfCountThreads = null;

	private JTextField jtfPart = null;

	private JTextField jtfX = null;

	private JTextField jtfY = null;

	private JTextField jtfZ = null;

	private JTextField jtfD = null;

	private JScrollPane jspOutput = null;

	private JTextArea jtaOuptut = null;

	private JComboBox jcbFncRo = null;

	/**
	 * This is the default constructor
	 */
	public MainFrame() {
		super();		
		initialize();
	}
	
	/**
	 * This is the default constructor
	 */
	public MainFrame(Parameters parameters) {		
		super();		
		initialize();
		
		this.jtfCountThreads.setText(String.valueOf(parameters.getCountThreads()));
		this.jtfPart.setText(String.valueOf(parameters.getPart()));
		this.jtfX.setText(String.valueOf(parameters.getX()));
		this.jtfY.setText(String.valueOf(parameters.getY()));
		this.jtfZ.setText(String.valueOf(parameters.getZ()));
		this.jtfD.setText(String.valueOf(parameters.getD()));		
		this.jcbFncRo.setSelectedIndex(parameters.getRo().getFnc().ordinal());
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(382, 425);
		this.setContentPane(getJContentPane());
		this.setTitle(" Vpoet hmotnosti kvdru");
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.jtaOuptut.setText("");
		this.setVisible(true);	
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.fill = GridBagConstraints.BOTH;
			gridBagConstraints12.gridy = 6;
			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints12.gridx = 1;
			GridBagConstraints gridBagConstraints111 = new GridBagConstraints();
			gridBagConstraints111.fill = GridBagConstraints.BOTH;
			gridBagConstraints111.gridy = 8;
			gridBagConstraints111.weightx = 1.0;
			gridBagConstraints111.weighty = 1.0;
			gridBagConstraints111.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints111.gridwidth = 2;
			gridBagConstraints111.gridx = 0;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.fill = GridBagConstraints.BOTH;
			gridBagConstraints8.gridy = 5;
			gridBagConstraints8.weightx = 1.0;
			gridBagConstraints8.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints8.gridx = 1;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = GridBagConstraints.BOTH;
			gridBagConstraints7.gridy = 4;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints7.gridx = 1;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = GridBagConstraints.BOTH;
			gridBagConstraints6.gridy = 3;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints6.gridx = 1;
			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.fill = GridBagConstraints.BOTH;
			gridBagConstraints51.gridy = 2;
			gridBagConstraints51.weightx = 1.0;
			gridBagConstraints51.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints51.gridx = 1;
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.fill = GridBagConstraints.BOTH;
			gridBagConstraints41.gridy = 1;
			gridBagConstraints41.weightx = 1.0;
			gridBagConstraints41.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints41.gridx = 1;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.fill = GridBagConstraints.BOTH;
			gridBagConstraints31.gridy = 0;
			gridBagConstraints31.weightx = 1.0;
			gridBagConstraints31.insets = new Insets(5, 15, 5, 25);
			gridBagConstraints31.gridx = 1;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 0;
			gridBagConstraints21.gridwidth = 2;
			gridBagConstraints21.insets = new Insets(15, 5, 15, 5);
			gridBagConstraints21.gridy = 7;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints11.anchor = GridBagConstraints.EAST;
			gridBagConstraints11.gridy = 6;
			jlFncRo = new JLabel();
			jlFncRo.setText("Funkce hustoty");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints5.anchor = GridBagConstraints.EAST;
			gridBagConstraints5.gridy = 5;
			jlD = new JLabel();
			jlD.setText("Integran krok");
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.anchor = GridBagConstraints.EAST;
			gridBagConstraints4.gridy = 4;
			jlZ = new JLabel();
			jlZ.setText("Z");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints3.anchor = GridBagConstraints.EAST;
			gridBagConstraints3.gridy = 3;
			jlY = new JLabel();
			jlY.setText("Y");
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.anchor = GridBagConstraints.EAST;
			gridBagConstraints2.gridy = 2;
			jlX = new JLabel();
			jlX.setText("X");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.anchor = GridBagConstraints.EAST;
			gridBagConstraints1.gridy = 1;
			jlPart = new JLabel();
			jlPart.setText("Dl prce");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.anchor = GridBagConstraints.EAST;
			gridBagConstraints.gridy = 0;
			jlCountThreads = new JLabel();
			jlCountThreads.setText("Poet vlken");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jlCountThreads, gridBagConstraints);
			jContentPane.add(jlPart, gridBagConstraints1);
			jContentPane.add(jlX, gridBagConstraints2);
			jContentPane.add(jlY, gridBagConstraints3);
			jContentPane.add(jlZ, gridBagConstraints4);
			jContentPane.add(jlD, gridBagConstraints5);
			jContentPane.add(jlFncRo, gridBagConstraints11);
			jContentPane.add(getJbStart(), gridBagConstraints21);
			jContentPane.add(getJtfCountThreads(), gridBagConstraints31);
			jContentPane.add(getJtfPart(), gridBagConstraints41);
			jContentPane.add(getJtfX(), gridBagConstraints51);
			jContentPane.add(getJtfY(), gridBagConstraints6);
			jContentPane.add(getJtfZ(), gridBagConstraints7);
			jContentPane.add(getJtfD(), gridBagConstraints8);
			jContentPane.add(getJspOutput(), gridBagConstraints111);
			jContentPane.add(getJcbFncRo(), gridBagConstraints12);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jbStart	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbStart() {
		if (jbStart == null) {
			jbStart = new JButton();
			jbStart.setText("Spustit vpoet");
			jbStart.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent event) {
					try {
						Parameters parameters = MainFrame.this.getParameters();  // nacteni parametru
						
						DialogThread dialogThread = new DialogThread(MainFrame.this, parameters);  // vlakno s dialogem a vypoctem
						dialogThread.start();  // spusteni vlakna
					}
					catch (Exception e) {
						 JOptionPane.showMessageDialog(MainFrame.this, e.getMessage(), "Chyba", JOptionPane.ERROR_MESSAGE);
					}
				}
			});
		}
		return jbStart;
	}

	/**
	 * This method initializes jtfCountThreads	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtfCountThreads() {
		if (jtfCountThreads == null) {
			jtfCountThreads = new JTextField();
			jtfCountThreads.setText("1");
		}
		return jtfCountThreads;
	}

	/**
	 * This method initializes jtfPart	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtfPart() {
		if (jtfPart == null) {
			jtfPart = new JTextField();
			jtfPart.setText("100");
		}
		return jtfPart;
	}

	/**
	 * This method initializes jtfX	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtfX() {
		if (jtfX == null) {
			jtfX = new JTextField();
			jtfX.setText("1");
		}
		return jtfX;
	}

	/**
	 * This method initializes jtfY	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtfY() {
		if (jtfY == null) {
			jtfY = new JTextField();
			jtfY.setText("1");
		}
		return jtfY;
	}

	/**
	 * This method initializes jtfZ	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtfZ() {
		if (jtfZ == null) {
			jtfZ = new JTextField();
			jtfZ.setText("1");
		}
		return jtfZ;
	}

	/**
	 * This method initializes jtfD	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtfD() {
		if (jtfD == null) {
			jtfD = new JTextField();
			jtfD.setText("1");
		}
		return jtfD;
	}

	/**
	 * This method initializes jspOutput	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJspOutput() {
		if (jspOutput == null) {
			jspOutput = new JScrollPane();
			jspOutput.setViewportView(getJtaOuptut());
		}
		return jspOutput;
	}

	/**
	 * This method initializes jtaOuptut	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJtaOuptut() {
		if (jtaOuptut == null) {
			jtaOuptut = new JTextArea();
		}
		return jtaOuptut;
	}

	/**
	 * This method initializes jcbFncRo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJcbFncRo() {
		if (jcbFncRo == null) {
			jcbFncRo = new JComboBox(Fncs.values());
		}
		return jcbFncRo;
	}
	
	public Parameters getParameters() throws ArgumentsException {
		Parameters parameters = new Parameters();
		
		parameters.setCountThreads(Integer.parseInt(jtfCountThreads.getText()));
		
		if (parameters.getCountThreads() <= 0)
			throw new ArgumentsException();
		
		parameters.setPart(Float.parseFloat(jtfPart.getText()));
		
		if ((parameters.getPart() <= 0f) || (parameters.getPart() > 100f))
			throw new ArgumentsException();
		
		parameters.setX(Float.parseFloat(jtfX.getText()));
		parameters.setY(Float.parseFloat(jtfY.getText()));
		parameters.setZ(Float.parseFloat(jtfZ.getText()));
				
		parameters.setD(Float.parseFloat(jtfD.getText()));
		
		if (parameters.getD() <= 0f)
			throw new ArgumentsException();
			
		int value = jcbFncRo.getSelectedIndex() + 1;
			
		if (value == 1)
			parameters.setRo(new FncConstant());
		else if (value == 2)
			parameters.setRo(new FncX());
		else if (value == 3)
			parameters.setRo(new FncXYZ());
		else
			throw new ArgumentsException();
		
		return parameters;
	}
	
	public void writeText(String string) {
		jtaOuptut.append(string);
		jtaOuptut.append("\n");
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
