package ppr.threading;

public class ThreadCounter {
	private int threadNo = 0;
	private int counter = 0;
	private Object lock = new Object();
	
	public ThreadCounter(int threadNo){
		this.threadNo = threadNo;
	}
	
	public synchronized void increment(){
		this.counter++;
		synchronized(this.lock){
			this.lock.notifyAll();
		}
	}
	
	public void waitForAll(){
		synchronized(lock){
			while(this.counter < this.threadNo){
				try {
					this.lock.wait();
				} catch (InterruptedException e) {}
			}
		}
	}
}
