package ppr.threading;

import java.util.ArrayList;

public class WorkingThread extends Thread {
	private byte[][] data;
	private ArrayList<Integer> queue;
	private ThreadCounter tc;
	private int k;
	
	public WorkingThread(ArrayList<Integer> queue,byte[][] data, int k,ThreadCounter tc){
		this.queue = queue;
		this.data = data;
		this.k = k;
		this.tc = tc;
	}
	
	@Override
	public void run() {
		int index;
		while(true){
			
			synchronized(this.queue){
				if(this.queue.size() == 0){
					this.tc.increment();
					break;
				}else{
					index = this.queue.remove(0);
				}
			}
			//System.out.println(this.getName() + " altering index " + index );
			//process data
			int j;
			if(index < 0 && index >= data.length) continue;
			for(int i = 0; i < data[index].length; i++){
				j = (data[index][i] < 0)? data[index][i]+256:data[index][i];
				data[index][i] = (byte)((k-j < 0)? 0:k-j);
			}
		}
	}
	
}
