package ppr.threads.app;

import ppr.threads.app.ro.FncConstant;
import ppr.threads.app.ro.FncX;
import ppr.threads.app.ro.FncXYZ;
import ppr.threads.inteface.Reader;

/**
 * Trida pro nacteni argumentu programu. 
 *
 */
public class ReadAppArguments implements Reader {
	private Parameters parameters = null;
	private String args[] = null;
	
	/**
	 * Vytvori instanci tridy.
	 * @param args pole s argumenty programu - delka 7
 	 */
	public ReadAppArguments(String[] args) {
		this.parameters = new Parameters();
		this.args = args;
	}

	/**
	 * Vrati zpracovane parametry vypoctu a zaroven je zkontroluje. Pri chybe vyvola vyjimku.
	 */
	public Parameters getParameters() throws ArgumentsException {	
		this.parameters.setCountThreads(Integer.parseInt(args[0]));
		
		if (this.parameters.getCountThreads() <= 0)
			throw new ArgumentsException();
		
		this.parameters.setPart(Float.parseFloat(args[1]));
		
		if ((this.parameters.getPart() <= 0f) || (this.parameters.getPart() > 100f))
			throw new ArgumentsException();
		
		this.parameters.setX(Float.parseFloat(args[2]));
		this.parameters.setY(Float.parseFloat(args[3]));
		this.parameters.setZ(Float.parseFloat(args[4]));
				
		this.parameters.setD(Float.parseFloat(args[5]));
		
		if (this.parameters.getD() <= 0f)
			throw new ArgumentsException();
			
		int value = Integer.parseInt(args[6]);
			
		if (value == 1)
			this.parameters.setRo(new FncConstant());
		else if (value == 2)
			this.parameters.setRo(new FncX());
		else if (value == 3)
			this.parameters.setRo(new FncXYZ());
		else
			throw new ArgumentsException();	
		
		return parameters;
	}
}